from __future__ import annotations
import typing
__all__ = ['AABBTreePolyline2', 'AABBTreePolyline3', 'AffineXf2d', 'AffineXf2f', 'AffineXf3d', 'AffineXf3f', 'BooleanOperation', 'BooleanResMapObj', 'BooleanResult', 'BooleanResultMapper', 'BoostBitSet', 'Box2d', 'Box2f', 'Box3d', 'Box3f', 'Color', 'Contour2d', 'Contour2f', 'Contour3d', 'Contour3f', 'ContourToDistanceMapParams', 'Contours2d', 'Contours2f', 'Contours3d', 'Contours3f', 'DecimateResult', 'DecimateSettings', 'DecimateStrategy', 'DistanceMap', 'DistanceMapToWorld', 'EdgeBitSet', 'EdgeId', 'EdgeMap', 'EdgeMetric', 'EdgePoint', 'ExpectedVoid', 'FaceBitSet', 'FaceFace', 'FaceHashMap', 'FaceId', 'FaceIncidence', 'FaceMap', 'FaceNormals', 'FillHoleMetric', 'FillHoleParams', 'FillHoleParamsMultipleEdgesResolveMode', 'FindOverhangsSettings', 'FloatGrid', 'GeneralOffsetParameters', 'GeneralOffsetParametersMode', 'GeodesicPathApprox', 'GridType', 'HolesVertIds', 'ICP', 'ICPMethod', 'ICPMode', 'ICPProperties', 'IntersectionPrecomputesd', 'IntersectionPrecomputesf', 'LaplacianEdgeWeightsParam', 'Line3d', 'Line3f', 'LineSegm2f', 'LineSegm3f', 'LoadDCMResult', 'LoadDCMResults', 'LoadingTiffSettings', 'Matrix2d', 'Matrix2f', 'Matrix3d', 'Matrix3f', 'Mesh', 'MeshBuilderSettings', 'MeshIntersectionResult', 'MeshLoadSettings', 'MeshPart', 'MeshProjectionResult', 'MeshRelaxParams', 'MeshSignedDistanceResult', 'MeshToDistanceMapParams', 'MeshToDistanceVolumeParams', 'MeshToVolumeParams', 'MeshToVolumeParamsType', 'MeshTopology', 'MeshTriPoint', 'OffsetParameters', 'PackMapping', 'PartMapping', 'Path', 'Plane3f', 'PointCloud', 'PointOnFace', 'Polyline2', 'Polyline3', 'PolylineTopology', 'RelaxParams', 'SceneObject', 'SegmPointf', 'SharpOffsetParameters', 'SignDetectionMode', 'SignedDistanceToMeshResult', 'SimpleVolume', 'SlicePlane', 'SphereParams', 'StitchHolesParams', 'SubdivideSettings', 'SurfacePath', 'SurfacePaths', 'SymbolMeshParams', 'TextAlignParams', 'ThreeVertIds', 'TriPointf', 'Triangulation', 'TriangulationParameters', 'UndirectedEdgeBitSet', 'UndirectedEdgeId', 'UndirectedEdgeMap', 'UndirectedEdgeUndirectedEdge', 'UniteManyMeshesParams', 'VdbVolume', 'Vector2d', 'Vector2f', 'Vector2i', 'Vector3d', 'Vector3f', 'Vector3i', 'VectorFloatByVert', 'VertBitSet', 'VertColorMap', 'VertCoords', 'VertCoords2', 'VertHashMap', 'VertId', 'VertMap', 'VertPair', 'ViewportId', 'ViewportMask', 'VoxelsSaveSavingSettings', 'WholeEdgeHashMap', 'WholeEdgeMap', 'WindingMode', 'addBaseToPlanarMesh', 'alignTextToMesh', 'angle', 'boolean', 'buildBottom', 'buildCylinderBetweenTwoHoles', 'buildShortestPath', 'buildShortestPathBiDir', 'buildSmallestMetricPath', 'buildSmallestMetricPathBiDir', 'calcOrientedArea', 'computeDistanceMapD', 'computeGeodesicPath', 'computePerFaceNormals', 'computePerVertNormals', 'computeSurfaceDistances', 'copyMesh', 'createSymbolsMesh', 'cross', 'cutMeshWithPlane', 'decimateMesh', 'detectBasisTunnels', 'detectTunnelFaces', 'dilateRegion', 'dilateRegionByMetric', 'distanceMapTo2DIsoPolyline', 'distanceMapToMesh', 'dot', 'edgeCurvMetric', 'edgeLengthMetric', 'edgeTableMetric', 'erodeRegion', 'erodeRegionByMetric', 'expand', 'extractPlaneSections', 'fillContourLeft', 'fillContourLeftByGraphCut', 'fillHole', 'findCollidingTriangles', 'findDegenerateFaces', 'findHoleVertIdsByHoleEdges', 'findLeftBoundary', 'findMaxDistanceSq', 'findMaxDistanceSqOneWay', 'findOverhangs', 'findProjection', 'findRightBoundary', 'findSelfCollidingEdges', 'findSelfCollidingTriangles', 'findSelfCollidingTrianglesBS', 'findSignedDistance', 'fixMultipleEdges', 'fixSelfIntersections', 'fixUndercuts', 'floatGridToVdbVolume', 'generalOffsetMesh', 'getAllComponents', 'getAllComponentsVerts', 'getCircumscribedMetric', 'getComplexFillMetric', 'getComponent', 'getComponentVerts', 'getEdgeLengthFillMetric', 'getEdgeLengthStitchMetric', 'getFacesByMinEdgeLength', 'getIncidentFaces', 'getIncidentVerts', 'getInnerFaces', 'getInnerVerts', 'getLargestComponent', 'getLargestComponentVerts', 'getMinAreaMetric', 'getPlaneFillMetric', 'getSelectedMesh', 'getUniversalMetric', 'gridToMesh', 'hasMultipleEdges', 'identityMetric', 'intersection', 'loadDCMFolder', 'loadDCMsFolder', 'loadDistanceMapFromImage', 'loadLines', 'loadMesh', 'loadPoints', 'loadSceneObject', 'loadTiffDir', 'loadVoxels', 'makeConvexHull', 'makeCube', 'makeCylinder', 'makeCylinderAdvanced', 'makeDegenerateBandAroundRegion', 'makeOuterHalfTorus', 'makeSphere', 'makeTorus', 'makeTorusWithComponents', 'makeTorusWithSelfIntersections', 'makeTorusWithSpikes', 'makeTorusWithUndercut', 'makeUVSphere', 'mergeMehses', 'meshRegularMap', 'meshToDistanceField', 'meshToDistanceVolume', 'meshToLevelSet', 'meshToPointCloud', 'meshToVolume', 'mixed', 'mult', 'offsetMesh', 'planeSectionsToContours2f', 'pointGridSampling', 'pointUniformSampling', 'positionVertsSmoothly', 'projectAllMeshVertices', 'rayMeshIntersect', 'relax', 'relaxKeepVolume', 'removeSpikes', 'saveAllSlicesToImage', 'saveDistanceMapToImage', 'saveLines', 'saveMesh', 'savePoints', 'saveSceneObject', 'saveSliceToImage', 'saveVoxels', 'segmentByGraphCut', 'setMeshToSelected', 'shrink', 'simpleVolumeToDenseGrid', 'simpleVolumeToVdbVolume', 'subdivideMesh', 'suggestVoxelSize', 'surfacePathLength', 'surroundingContour', 'thickenMesh', 'topologyFromTriangles', 'transformed', 'triangulateContours', 'triangulatePointCloud', 'uniteManyMeshes', 'vectorColor', 'vectorConstMeshPtr', 'vectorEdgePath', 'vectorEdges', 'vectorFaceBitSet', 'vectorFaceFace', 'vectorFaces', 'vectorFloat', 'vectorICPVertPair', 'vectorMesh', 'vectorThreeVertIds', 'vectorUndirectedEdgeUndirectedEdge', 'vectorUndirectedEdges', 'vectorVertBitSet', 'vectorVerts', 'voxelBooleanIntersect', 'voxelBooleanSubtract', 'voxelBooleanUnite']
class AABBTreePolyline2:
    pass
class AABBTreePolyline3:
    pass
class AffineXf2d:
    """
    affine transformation: y = A*x + b, where A in VxV, and b in V
    """
    __hash__: typing.ClassVar[None] = None
    A: Matrix2d
    b: Vector2d
    @staticmethod
    def linear(A: Matrix2d) -> AffineXf2d:
        """
        creates linear-only transformation (without translation)
        """
    @staticmethod
    def translation(b: Vector2d) -> AffineXf2d:
        """
        creates translation-only transformation (with identity linear component)
        """
    @staticmethod
    def xfAround(A: Matrix2d, stable: Vector2d) -> AffineXf2d:
        """
        creates transformation with given linear part with given stable point
        """
    def __call__(self, arg0: Vector2d) -> Vector2d:
        """
        application of the transformation to a point
        """
    def __eq__(self, arg0: AffineXf2d) -> bool:
        ...
    def __init__(self) -> None:
        ...
    def __mul__(self, arg0: AffineXf2d) -> AffineXf2d:
        ...
    def inverse(self) -> AffineXf2d:
        """
        computes inverse transformation
        """
    def linearOnly(self, x: Vector2d) -> Vector2d:
        """
        applies only linear part of the transformation to given vector (e.g. to normal) skipping adding shift (b)
        for example if this is a rigid transformation, then only rotates input vector
        """
class AffineXf2f:
    """
    affine transformation: y = A*x + b, where A in VxV, and b in V
    """
    __hash__: typing.ClassVar[None] = None
    A: Matrix2f
    b: Vector2f
    @staticmethod
    def linear(A: Matrix2f) -> AffineXf2f:
        """
        creates linear-only transformation (without translation)
        """
    @staticmethod
    def translation(b: Vector2f) -> AffineXf2f:
        """
        creates translation-only transformation (with identity linear component)
        """
    @staticmethod
    def xfAround(A: Matrix2f, stable: Vector2f) -> AffineXf2f:
        """
        creates transformation with given linear part with given stable point
        """
    def __call__(self, arg0: Vector2f) -> Vector2f:
        """
        application of the transformation to a point
        """
    def __eq__(self, arg0: AffineXf2f) -> bool:
        ...
    def __init__(self) -> None:
        ...
    def __mul__(self, arg0: AffineXf2f) -> AffineXf2f:
        ...
    def inverse(self) -> AffineXf2f:
        """
        computes inverse transformation
        """
    def linearOnly(self, x: Vector2f) -> Vector2f:
        """
        applies only linear part of the transformation to given vector (e.g. to normal) skipping adding shift (b)
        for example if this is a rigid transformation, then only rotates input vector
        """
class AffineXf3d:
    """
    affine transformation: y = A*x + b, where A in VxV, and b in V
    """
    __hash__: typing.ClassVar[None] = None
    A: Matrix3d
    b: Vector3d
    @staticmethod
    def linear(A: Matrix3d) -> AffineXf3d:
        """
        creates linear-only transformation (without translation)
        """
    @staticmethod
    def translation(b: Vector3d) -> AffineXf3d:
        """
        creates translation-only transformation (with identity linear component)
        """
    @staticmethod
    def xfAround(A: Matrix3d, stable: Vector3d) -> AffineXf3d:
        """
        creates transformation with given linear part with given stable point
        """
    def __call__(self, arg0: Vector3d) -> Vector3d:
        """
        application of the transformation to a point
        """
    def __eq__(self, arg0: AffineXf3d) -> bool:
        ...
    def __init__(self) -> None:
        ...
    def __mul__(self, arg0: AffineXf3d) -> AffineXf3d:
        ...
    def inverse(self) -> AffineXf3d:
        """
        computes inverse transformation
        """
    def linearOnly(self, x: Vector3d) -> Vector3d:
        """
        applies only linear part of the transformation to given vector (e.g. to normal) skipping adding shift (b)
        for example if this is a rigid transformation, then only rotates input vector
        """
class AffineXf3f:
    """
    affine transformation: y = A*x + b, where A in VxV, and b in V
    """
    __hash__: typing.ClassVar[None] = None
    A: Matrix3f
    b: Vector3f
    @staticmethod
    def linear(A: Matrix3f) -> AffineXf3f:
        """
        creates linear-only transformation (without translation)
        """
    @staticmethod
    def translation(b: Vector3f) -> AffineXf3f:
        """
        creates translation-only transformation (with identity linear component)
        """
    @staticmethod
    def xfAround(A: Matrix3f, stable: Vector3f) -> AffineXf3f:
        """
        creates transformation with given linear part with given stable point
        """
    def __call__(self, arg0: Vector3f) -> Vector3f:
        """
        application of the transformation to a point
        """
    def __eq__(self, arg0: AffineXf3f) -> bool:
        ...
    def __init__(self) -> None:
        ...
    def __mul__(self, arg0: AffineXf3f) -> AffineXf3f:
        ...
    def inverse(self) -> AffineXf3f:
        """
        computes inverse transformation
        """
    def linearOnly(self, x: Vector3f) -> Vector3f:
        """
        applies only linear part of the transformation to given vector (e.g. to normal) skipping adding shift (b)
        for example if this is a rigid transformation, then only rotates input vector
        """
class BooleanOperation:
    """
    Enum class of available CSG operations
    
    Members:
    
      InsideA : Part of mesh `A` that is inside of mesh `B`
    
      InsideB : Part of mesh `B` that is inside of mesh `A`
    
      OutsideA : Part of mesh `A` that is outside of mesh `B`
    
      OutsideB : Part of mesh `B` that is outside of mesh `A`
    
      Union : Union surface of two meshes (outside parts)
    
      Intersection : Intersection surface of two meshes (inside parts)
    
      DifferenceAB : Surface of mesh `A` - surface of mesh `B` (outside `A` - inside `B`)
    
      DifferenceBA : Surface of mesh `B` - surface of mesh `A` (outside `B` - inside `A`)
    """
    DifferenceAB: typing.ClassVar[BooleanOperation]  # value = <BooleanOperation.DifferenceAB: 7>
    DifferenceBA: typing.ClassVar[BooleanOperation]  # value = <BooleanOperation.DifferenceBA: 6>
    InsideA: typing.ClassVar[BooleanOperation]  # value = <BooleanOperation.InsideA: 0>
    InsideB: typing.ClassVar[BooleanOperation]  # value = <BooleanOperation.InsideB: 1>
    Intersection: typing.ClassVar[BooleanOperation]  # value = <BooleanOperation.Intersection: 5>
    OutsideA: typing.ClassVar[BooleanOperation]  # value = <BooleanOperation.OutsideA: 2>
    OutsideB: typing.ClassVar[BooleanOperation]  # value = <BooleanOperation.OutsideB: 3>
    Union: typing.ClassVar[BooleanOperation]  # value = <BooleanOperation.Union: 4>
    __members__: typing.ClassVar[dict[str, BooleanOperation]]  # value = {'InsideA': <BooleanOperation.InsideA: 0>, 'InsideB': <BooleanOperation.InsideB: 1>, 'OutsideA': <BooleanOperation.OutsideA: 2>, 'OutsideB': <BooleanOperation.OutsideB: 3>, 'Union': <BooleanOperation.Union: 4>, 'Intersection': <BooleanOperation.Intersection: 5>, 'DifferenceAB': <BooleanOperation.DifferenceAB: 7>, 'DifferenceBA': <BooleanOperation.DifferenceBA: 6>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class BooleanResMapObj:
    """
    Input object index enum
    
    Members:
    
      A
    
      B
    """
    A: typing.ClassVar[BooleanResMapObj]  # value = <BooleanResMapObj.A: 0>
    B: typing.ClassVar[BooleanResMapObj]  # value = <BooleanResMapObj.B: 1>
    __members__: typing.ClassVar[dict[str, BooleanResMapObj]]  # value = {'A': <BooleanResMapObj.A: 0>, 'B': <BooleanResMapObj.B: 1>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class BooleanResult:
    """
    This structure store result mesh of MR::boolean or some error info
    """
    def __init__(self) -> None:
        ...
    def valid(self) -> bool:
        """
        Returns true if boolean succeed, false otherwise
        """
    @property
    def errorString(self) -> str:
        """
        Holds error message, empty if boolean succeed
        """
    @errorString.setter
    def errorString(self, arg0: str) -> None:
        ...
    @property
    def mesh(self) -> Mesh:
        """
        Result mesh of boolean operation, if error occurred it would be empty
        """
    @mesh.setter
    def mesh(self, arg0: Mesh) -> None:
        ...
    @property
    def meshABadContourFaces(self) -> FaceBitSet:
        """
        If input contours have intersections, this face bit set presents faces of mesh `A` on which contours intersect
        """
    @meshABadContourFaces.setter
    def meshABadContourFaces(self, arg0: FaceBitSet) -> None:
        ...
    @property
    def meshBBadContourFaces(self) -> FaceBitSet:
        """
        If input contours have intersections, this face bit set presents faces of mesh `B` on which contours intersect
        """
    @meshBBadContourFaces.setter
    def meshBBadContourFaces(self, arg0: FaceBitSet) -> None:
        ...
class BooleanResultMapper:
    """
    This structure allows to map faces, vertices and edges of mesh `A` and mesh `B` input of MR::boolean to result mesh topology primitives
    """
    def __init__(self) -> None:
        ...
    @typing.overload
    def map(self, oldBS: VertBitSet, obj: BooleanResMapObj) -> VertBitSet:
        """
        Returns vertices bitset of result mesh corresponding input one
        """
    @typing.overload
    def map(self, oldBS: EdgeBitSet, obj: BooleanResMapObj) -> EdgeBitSet:
        """
        Returns edges bitset of result mesh corresponding input one
        """
    @typing.overload
    def map(self, oldBS: FaceBitSet, obj: BooleanResMapObj) -> FaceBitSet:
        """
        Returns faces bitset of result mesh corresponding input one
        """
class BoostBitSet:
    def count(self) -> int:
        ...
    def size(self) -> int:
        ...
class Box2d:
    """
    Box given by its min- and max- corners
    """
    __hash__: typing.ClassVar[None] = None
    max: Vector2d
    def __eq__(self, arg0: Box2d) -> bool:
        ...
    def __init__(self) -> None:
        ...
    def __ne__(self, arg0: Box2d) -> bool:
        ...
    def center(self) -> Vector2d:
        ...
    def contains(self, pt: Vector2d) -> bool:
        """
        checks whether given point is inside (including the surface) of the box
        """
    def diagonal(self) -> float:
        ...
    def getBoxClosestPointTo(self, pt: Vector2d) -> Vector2d:
        """
        returns closest point in the box to given point
        """
    def getDistanceSq(self, b: Box2d) -> float:
        """
        returns squared distance between this box and given one; returns zero if the boxes touch or intersect
        """
    @typing.overload
    def include(self, pt: Vector2d) -> None:
        """
        minimally increases the box to include given point
        """
    @typing.overload
    def include(self, b: Box2d) -> None:
        """
        minimally increases the box to include another box
        """
    def insignificantlyExpanded(self) -> Box2d:
        """
        expands min and max to their closest representable value
        """
    def intersect(self, b: Box2d) -> Box2d:
        """
        computes intersection between this and other box
        """
    def intersection(self, b: Box2d) -> Box2d:
        """
        computes intersection between this and other box
        """
    def intersects(self, b: Box2d) -> bool:
        """
        checks whether this box intersects or touches given box
        """
    def size(self) -> Vector2d:
        ...
    def valid(self) -> bool:
        ...
    def volume(self) -> float:
        ...
    @property
    def min(self) -> Vector2d:
        """
        create invalid box by default
        """
    @min.setter
    def min(self, arg0: Vector2d) -> None:
        ...
class Box2f:
    """
    Box given by its min- and max- corners
    """
    __hash__: typing.ClassVar[None] = None
    max: Vector2f
    def __eq__(self, arg0: Box2f) -> bool:
        ...
    def __init__(self) -> None:
        ...
    def __ne__(self, arg0: Box2f) -> bool:
        ...
    def center(self) -> Vector2f:
        ...
    def contains(self, pt: Vector2f) -> bool:
        """
        checks whether given point is inside (including the surface) of the box
        """
    def diagonal(self) -> float:
        ...
    def getBoxClosestPointTo(self, pt: Vector2f) -> Vector2f:
        """
        returns closest point in the box to given point
        """
    def getDistanceSq(self, b: Box2f) -> float:
        """
        returns squared distance between this box and given one; returns zero if the boxes touch or intersect
        """
    @typing.overload
    def include(self, pt: Vector2f) -> None:
        """
        minimally increases the box to include given point
        """
    @typing.overload
    def include(self, b: Box2f) -> None:
        """
        minimally increases the box to include another box
        """
    def insignificantlyExpanded(self) -> Box2f:
        """
        expands min and max to their closest representable value
        """
    def intersect(self, b: Box2f) -> Box2f:
        """
        computes intersection between this and other box
        """
    def intersection(self, b: Box2f) -> Box2f:
        """
        computes intersection between this and other box
        """
    def intersects(self, b: Box2f) -> bool:
        """
        checks whether this box intersects or touches given box
        """
    def size(self) -> Vector2f:
        ...
    def valid(self) -> bool:
        ...
    def volume(self) -> float:
        ...
    @property
    def min(self) -> Vector2f:
        """
        create invalid box by default
        """
    @min.setter
    def min(self, arg0: Vector2f) -> None:
        ...
class Box3d:
    """
    Box given by its min- and max- corners
    """
    __hash__: typing.ClassVar[None] = None
    max: Vector3d
    def __eq__(self, arg0: Box3d) -> bool:
        ...
    def __init__(self) -> None:
        ...
    def __ne__(self, arg0: Box3d) -> bool:
        ...
    def center(self) -> Vector3d:
        ...
    def contains(self, pt: Vector3d) -> bool:
        """
        checks whether given point is inside (including the surface) of the box
        """
    def diagonal(self) -> float:
        ...
    def getBoxClosestPointTo(self, pt: Vector3d) -> Vector3d:
        """
        returns closest point in the box to given point
        """
    def getDistanceSq(self, b: Box3d) -> float:
        """
        returns squared distance between this box and given one; returns zero if the boxes touch or intersect
        """
    @typing.overload
    def include(self, pt: Vector3d) -> None:
        """
        minimally increases the box to include given point
        """
    @typing.overload
    def include(self, b: Box3d) -> None:
        """
        minimally increases the box to include another box
        """
    def insignificantlyExpanded(self) -> Box3d:
        """
        expands min and max to their closest representable value
        """
    def intersect(self, b: Box3d) -> Box3d:
        """
        computes intersection between this and other box
        """
    def intersection(self, b: Box3d) -> Box3d:
        """
        computes intersection between this and other box
        """
    def intersects(self, b: Box3d) -> bool:
        """
        checks whether this box intersects or touches given box
        """
    def size(self) -> Vector3d:
        ...
    def valid(self) -> bool:
        ...
    def volume(self) -> float:
        ...
    @property
    def min(self) -> Vector3d:
        """
        create invalid box by default
        """
    @min.setter
    def min(self, arg0: Vector3d) -> None:
        ...
class Box3f:
    """
    Box given by its min- and max- corners
    """
    __hash__: typing.ClassVar[None] = None
    max: Vector3f
    def __eq__(self, arg0: Box3f) -> bool:
        ...
    def __init__(self) -> None:
        ...
    def __ne__(self, arg0: Box3f) -> bool:
        ...
    def center(self) -> Vector3f:
        ...
    def contains(self, pt: Vector3f) -> bool:
        """
        checks whether given point is inside (including the surface) of the box
        """
    def diagonal(self) -> float:
        ...
    def getBoxClosestPointTo(self, pt: Vector3f) -> Vector3f:
        """
        returns closest point in the box to given point
        """
    def getDistanceSq(self, b: Box3f) -> float:
        """
        returns squared distance between this box and given one; returns zero if the boxes touch or intersect
        """
    @typing.overload
    def include(self, pt: Vector3f) -> None:
        """
        minimally increases the box to include given point
        """
    @typing.overload
    def include(self, b: Box3f) -> None:
        """
        minimally increases the box to include another box
        """
    def insignificantlyExpanded(self) -> Box3f:
        """
        expands min and max to their closest representable value
        """
    def intersect(self, b: Box3f) -> Box3f:
        """
        computes intersection between this and other box
        """
    def intersection(self, b: Box3f) -> Box3f:
        """
        computes intersection between this and other box
        """
    def intersects(self, b: Box3f) -> bool:
        """
        checks whether this box intersects or touches given box
        """
    def size(self) -> Vector3f:
        ...
    def valid(self) -> bool:
        ...
    def volume(self) -> float:
        ...
    @property
    def min(self) -> Vector3f:
        """
        create invalid box by default
        """
    @min.setter
    def min(self, arg0: Vector3f) -> None:
        ...
class Color:
    a: int
    b: int
    g: int
    r: int
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, r: int, g: int, b: int, a: int = 255) -> None:
        ...
    @typing.overload
    def __init__(self, r: float, g: float, b: float, a: float = 1.0) -> None:
        ...
    def __repr__(self) -> str:
        ...
class Contour2d:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: Vector2d) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: Contour2d) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> Contour2d:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> Vector2d:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: Contour2d) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: Contour2d) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: Vector2d) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: Contour2d) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: Vector2d) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: Vector2d) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: Contour2d) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: Vector2d) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> Vector2d:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> Vector2d:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: Vector2d) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class Contour2f:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: Vector2f) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: Contour2f) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> Contour2f:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> Vector2f:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: Contour2f) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: Contour2f) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: Vector2f) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: Contour2f) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: Vector2f) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: Vector2f) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: Contour2f) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: Vector2f) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> Vector2f:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> Vector2f:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: Vector2f) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class Contour3d:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: Vector3d) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: Contour3d) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> Contour3d:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> Vector3d:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: Contour3d) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: Contour3d) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: Vector3d) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: Contour3d) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: Vector3d) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: Vector3d) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: Contour3d) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: Vector3d) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> Vector3d:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> Vector3d:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: Vector3d) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class Contour3f:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: Vector3f) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: Contour3f) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> Contour3f:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> Vector3f:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: Contour3f) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: Contour3f) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: Vector3f) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: Contour3f) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: Vector3f) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: Vector3f) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: Contour3f) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: Vector3f) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> Vector3f:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> Vector3f:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: Vector3f) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class ContourToDistanceMapParams:
    def __init__(self) -> None:
        ...
class Contours2d:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: Contour2d) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: Contours2d) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> Contours2d:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> Contour2d:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: Contours2d) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: Contours2d) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: Contour2d) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: Contours2d) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: Contour2d) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: Contour2d) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: Contours2d) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: Contour2d) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> Contour2d:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> Contour2d:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: Contour2d) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class Contours2f:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: Contour2f) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: Contours2f) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> Contours2f:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> Contour2f:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: Contours2f) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: Contours2f) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: Contour2f) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: Contours2f) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: Contour2f) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: Contour2f) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: Contours2f) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: Contour2f) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> Contour2f:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> Contour2f:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: Contour2f) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class Contours3d:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: Contour3d) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: Contours3d) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> Contours3d:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> Contour3d:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: Contours3d) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: Contours3d) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: Contour3d) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: Contours3d) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: Contour3d) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: Contour3d) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: Contours3d) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: Contour3d) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> Contour3d:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> Contour3d:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: Contour3d) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class Contours3f:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: Contour3f) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: Contours3f) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> Contours3f:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> Contour3f:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: Contours3f) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: Contours3f) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: Contour3f) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: Contours3f) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: Contour3f) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: Contour3f) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: Contours3f) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: Contour3f) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> Contour3f:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> Contour3f:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: Contour3f) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class DecimateResult:
    """
    Results of decimateMesh
    """
    def __init__(self) -> None:
        ...
    @property
    def errorIntroduced(self) -> float:
        """
        estimated distance deviation of decimated mesh from the original mesh
        """
    @errorIntroduced.setter
    def errorIntroduced(self, arg0: float) -> None:
        ...
    @property
    def facesDeleted(self) -> int:
        """
        Number deleted faces
        """
    @facesDeleted.setter
    def facesDeleted(self, arg0: int) -> None:
        ...
    @property
    def vertsDeleted(self) -> int:
        """
        Number deleted verts. Same as the number of performed collapses
        """
    @vertsDeleted.setter
    def vertsDeleted(self, arg0: int) -> None:
        ...
class DecimateSettings:
    """
    Parameters structure for decimateMesh
    """
    strategy: DecimateStrategy
    def __init__(self) -> None:
        ...
    @property
    def maxDeletedFaces(self) -> int:
        """
        Limit on the number of deleted faces
        """
    @maxDeletedFaces.setter
    def maxDeletedFaces(self, arg0: int) -> None:
        ...
    @property
    def maxDeletedVertices(self) -> int:
        """
        Limit on the number of deleted vertices
        """
    @maxDeletedVertices.setter
    def maxDeletedVertices(self, arg0: int) -> None:
        ...
    @property
    def maxEdgeLen(self) -> float:
        """
        Maximal possible edge length created during decimation
        """
    @maxEdgeLen.setter
    def maxEdgeLen(self, arg0: float) -> None:
        ...
    @property
    def maxError(self) -> float:
        """
        for DecimateStrategy::MinimizeError:
        	stop the decimation as soon as the estimated distance deviation from the original mesh is more than this value
        for DecimateStrategy::ShortestEdgeFirst only:
        	stop the decimation as soon as the shortest edge in the mesh is greater than this value
        """
    @maxError.setter
    def maxError(self, arg0: float) -> None:
        ...
    @property
    def maxTriangleAspectRatio(self) -> float:
        """
        Maximal possible aspect ratio of a triangle introduced during decimation
        """
    @maxTriangleAspectRatio.setter
    def maxTriangleAspectRatio(self, arg0: float) -> None:
        ...
    @property
    def optimizeVertexPos(self) -> bool:
        """
        if true then after each edge collapse the position of remaining vertex is optimized to
        minimize local shape change, if false then the edge is collapsed in one of its vertices, which keeps its position
        """
    @optimizeVertexPos.setter
    def optimizeVertexPos(self, arg0: bool) -> None:
        ...
    @property
    def packMesh(self) -> bool:
        """
        whether to pack mesh at the end
        """
    @packMesh.setter
    def packMesh(self, arg0: bool) -> None:
        ...
    @property
    def region(self) -> FaceBitSet:
        """
        Region on mesh to be decimated, it is updated during the operation
        """
    @region.setter
    def region(self, arg0: FaceBitSet) -> None:
        ...
    @property
    def stabilizer(self) -> float:
        """
        Small stabilizer is important to achieve good results on completely planar mesh parts,
        if your mesh is not-planer everywhere, then you can set it to zero
        """
    @stabilizer.setter
    def stabilizer(self, arg0: float) -> None:
        ...
    @property
    def subdivideParts(self) -> int:
        """
        If this value is more than 1, then virtually subdivides the mesh on given number of parts to process them in parallel (using many threads);
        unlike 
        ef decimateParallelMesh it does not create copies of mesh regions, so may take less memory to operate;
        IMPORTANT: please call mesh.packOptimally() before calling decimating with subdivideParts > 1, otherwise performance will be bad
        """
    @subdivideParts.setter
    def subdivideParts(self, arg0: int) -> None:
        ...
    @property
    def tinyEdgeLength(self) -> float:
        """
        edges not longer than this value will be collapsed even if it results in appearance of a triangle with high aspect ratio
        """
    @tinyEdgeLength.setter
    def tinyEdgeLength(self, arg0: float) -> None:
        ...
    @property
    def touchBdVertices(self) -> bool:
        """
        Whether to allow collapsing edges having at least one vertex on (region) boundary
        """
    @touchBdVertices.setter
    def touchBdVertices(self, arg0: bool) -> None:
        ...
class DecimateStrategy:
    """
    Defines the order of edge collapses inside Decimate algorithm
    
    Members:
    
      MinimizeError : the next edge to collapse will be the one that introduced minimal error to the surface
    
      ShortestEdgeFirst : the next edge to collapse will be the shortest one
    """
    MinimizeError: typing.ClassVar[DecimateStrategy]  # value = <DecimateStrategy.MinimizeError: 0>
    ShortestEdgeFirst: typing.ClassVar[DecimateStrategy]  # value = <DecimateStrategy.ShortestEdgeFirst: 1>
    __members__: typing.ClassVar[dict[str, DecimateStrategy]]  # value = {'MinimizeError': <DecimateStrategy.MinimizeError: 0>, 'ShortestEdgeFirst': <DecimateStrategy.ShortestEdgeFirst: 1>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class DistanceMap:
    def __init__(self) -> None:
        ...
    def clear(self) -> None:
        """
        clear all values, set resolutions to zero
        """
    @typing.overload
    def get(self, arg0: int, arg1: int) -> ...:
        """
        read X,Y value
        """
    @typing.overload
    def get(self, arg0: int) -> ...:
        """
        read value by index
        """
    def getInterpolated(self, arg0: float, arg1: float) -> ...:
        """
        bilinear interpolation between 4 pixels
        """
    def invalidateAll(self) -> None:
        """
        invalidate all pixels
        """
    @typing.overload
    def isValid(self, arg0: int, arg1: int) -> bool:
        """
        check if X,Y pixel is valid
        """
    @typing.overload
    def isValid(self, arg0: int) -> bool:
        """
        check if index pixel is valid
        """
    def resX(self) -> int:
        """
        X resolution
        """
    def resY(self) -> int:
        """
        Y resolution
        """
    @typing.overload
    def set(self, arg0: int, arg1: float) -> None:
        """
        write value by index
        """
    @typing.overload
    def set(self, arg0: int, arg1: int, arg2: float) -> None:
        """
        write X,Y value
        """
    @typing.overload
    def unset(self, arg0: int, arg1: int) -> None:
        """
        invalidate X,Y pixel
        """
    @typing.overload
    def unset(self, arg0: int) -> None:
        """
        invalidate by index
        """
class DistanceMapToWorld:
    """
    This structure store data to transform distance map to world coordinates
    """
    @typing.overload
    def __init__(self) -> None:
        """
        Default ctor init all fields with zeros, make sure to fill them manually
        """
    @typing.overload
    def __init__(self, arg0: MeshToDistanceMapParams) -> None:
        """
        Init fields by `MeshToDistanceMapParams` struct
        """
    @typing.overload
    def __init__(self, arg0: ContourToDistanceMapParams) -> None:
        """
        Init fields by `ContourToDistanceMapParams` struct
        """
    def toWorld(self, x: float, y: float, depth: float) -> Vector3f:
        """
        Get world coordinate by depth map info.
        x - float X coordinate of depth map: (0.0f - left corner of pixel 0, 1.0 - right corner of pixel 0 and left corner of pixel 1)
        y - float Y coordinate of depth map: (0.0f - left corner of pixel 0, 1.0 - right corner of pixel 0 and left corner of pixel 1)
        depth - value in distance map, represent depth in world
        """
    @property
    def direction(self) -> Vector3f:
        """
        Vector of depth direction.Note! Typically it should be normalized and orthogonal to `pixelXVec` `pixelYVec` plane.
        """
    @direction.setter
    def direction(self, arg0: Vector3f) -> None:
        ...
    @property
    def orgPoint(self) -> Vector3f:
        """
        World coordinates of distance map origin corner
        """
    @orgPoint.setter
    def orgPoint(self, arg0: Vector3f) -> None:
        ...
    @property
    def pixelXVec(self) -> Vector3f:
        """
        Vector in world space of pixel x positive direction.
        Note! Length is equal to pixel size. Typically it should be orthogonal to `pixelYVec`.
        """
    @pixelXVec.setter
    def pixelXVec(self, arg0: Vector3f) -> None:
        ...
    @property
    def pixelYVec(self) -> Vector3f:
        """
        Vector in world space of pixel y positive direction.
        Note! Length is equal to pixel size. Typically it should be orthogonal to `pixelXVec`.
        """
    @pixelYVec.setter
    def pixelYVec(self, arg0: Vector3f) -> None:
        ...
class EdgeBitSet(BoostBitSet):
    def __and__(self, arg0: EdgeBitSet) -> EdgeBitSet:
        ...
    def __iand__(self, arg0: EdgeBitSet) -> EdgeBitSet:
        ...
    def __init__(self) -> None:
        ...
    def __ior__(self, arg0: EdgeBitSet) -> EdgeBitSet:
        ...
    def __isub__(self, arg0: EdgeBitSet) -> EdgeBitSet:
        ...
    def __ixor__(self, arg0: EdgeBitSet) -> EdgeBitSet:
        ...
    def __or__(self, arg0: EdgeBitSet) -> EdgeBitSet:
        ...
    def __sub__(self, arg0: EdgeBitSet) -> EdgeBitSet:
        ...
    def __xor__(self, arg0: EdgeBitSet) -> EdgeBitSet:
        ...
    def flip(self) -> EdgeBitSet:
        ...
    def resize(self, arg0: int, arg1: bool) -> None:
        ...
    def set(self, arg0: EdgeId, arg1: bool) -> EdgeBitSet:
        ...
    def test(self, arg0: EdgeId) -> bool:
        ...
class EdgeId:
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: int) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: UndirectedEdgeId) -> None:
        ...
    def get(self) -> int:
        ...
    def sym(self) -> EdgeId:
        """
        returns identifier of the edge with same ends but opposite orientation
        """
    def undirected(self) -> UndirectedEdgeId:
        """
        returns unique identifier of the edge ignoring its direction
        """
    def valid(self) -> bool:
        ...
class EdgeMap:
    vec: vectorEdges
    def __init__(self) -> None:
        ...
class EdgeMetric:
    pass
class EdgePoint:
    """
    encodes a point on a mesh edge
    """
    __hash__: typing.ClassVar[None] = None
    e: EdgeId
    def __eq__(self, arg0: EdgePoint) -> bool:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, e: EdgeId, a: float) -> None:
        ...
    @typing.overload
    def getClosestVertex(self, topology: MeshTopology) -> VertId:
        """
        returns one of two edge vertices, closest to this point
        """
    @typing.overload
    def getClosestVertex(self, topology: PolylineTopology) -> VertId:
        """
        returns one of two edge vertices, closest to this point
        """
    @typing.overload
    def inVertex(self, topology: MeshTopology) -> VertId:
        """
        returns valid vertex id if the point is in vertex, otherwise returns invalid id
        """
    @typing.overload
    def inVertex(self, topology: PolylineTopology) -> VertId:
        """
        returns valid vertex id if the point is in vertex, otherwise returns invalid id
        """
    @typing.overload
    def inVertex(self) -> bool:
        """
        returns true if the point is in a vertex
        """
    def sym(self) -> EdgePoint:
        """
        represents the same point relative to sym edge in
        """
    @property
    def a(self) -> SegmPointf:
        """
        a in [0,1], a=0 => point is in org( e ), a=1 => point is in dest( e )
        """
    @a.setter
    def a(self, arg0: SegmPointf) -> None:
        ...
class ExpectedVoid:
    def error(self) -> str:
        ...
    def has_value(self) -> bool:
        ...
class FaceBitSet(BoostBitSet):
    def __and__(self, arg0: FaceBitSet) -> FaceBitSet:
        ...
    def __iand__(self, arg0: FaceBitSet) -> FaceBitSet:
        ...
    def __init__(self) -> None:
        ...
    def __ior__(self, arg0: FaceBitSet) -> FaceBitSet:
        ...
    def __isub__(self, arg0: FaceBitSet) -> FaceBitSet:
        ...
    def __ixor__(self, arg0: FaceBitSet) -> FaceBitSet:
        ...
    def __or__(self, arg0: FaceBitSet) -> FaceBitSet:
        ...
    def __sub__(self, arg0: FaceBitSet) -> FaceBitSet:
        ...
    def __xor__(self, arg0: FaceBitSet) -> FaceBitSet:
        ...
    def flip(self) -> FaceBitSet:
        ...
    def resize(self, arg0: int, arg1: bool) -> None:
        ...
    def set(self, arg0: FaceId, arg1: bool) -> FaceBitSet:
        ...
    def test(self, arg0: FaceId) -> bool:
        ...
class FaceFace:
    aFace: FaceId
    bFace: FaceId
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, a: FaceId, b: FaceId) -> None:
        ...
class FaceHashMap:
    def __bool__(self) -> bool:
        """
        Check whether the map is nonempty
        """
    @typing.overload
    def __contains__(self, arg0: FaceId) -> bool:
        ...
    @typing.overload
    def __contains__(self, arg0: typing.Any) -> bool:
        ...
    def __delitem__(self, arg0: FaceId) -> None:
        ...
    def __getitem__(self, arg0: FaceId) -> FaceId:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __repr__(self) -> str:
        """
        Return the canonical string representation of this map.
        """
    def __setitem__(self, arg0: FaceId, arg1: FaceId) -> None:
        ...
    def items(self) -> typing.ItemsView[FaceHashMap]:
        ...
    def keys(self) -> typing.KeysView[FaceHashMap]:
        ...
    def size(self) -> int:
        ...
    def values(self) -> typing.ValuesView[FaceHashMap]:
        ...
class FaceId:
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: int) -> None:
        ...
    def get(self) -> int:
        ...
    def valid(self) -> bool:
        ...
class FaceIncidence:
    """
    Face incidence type
    
    Members:
    
      PerEdge : face can have neighbor only via edge
    
      PerVertex : face can have neighbor via vertex
    """
    PerEdge: typing.ClassVar[FaceIncidence]  # value = <FaceIncidence.PerEdge: 0>
    PerVertex: typing.ClassVar[FaceIncidence]  # value = <FaceIncidence.PerVertex: 1>
    __members__: typing.ClassVar[dict[str, FaceIncidence]]  # value = {'PerEdge': <FaceIncidence.PerEdge: 0>, 'PerVertex': <FaceIncidence.PerVertex: 1>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class FaceMap:
    vec: vectorFaces
    def __init__(self) -> None:
        ...
class FaceNormals:
    vec: Contour3f
    def __init__(self) -> None:
        ...
class FillHoleMetric:
    """
    This is struct used as optimization metric of fillHole and buildCylinderBetweenTwoHoles functions
    """
    def __init__(self) -> None:
        ...
class FillHoleParams:
    """
    Structure has some options to control fillHole
    """
    multipleEdgesResolveMode: FillHoleParamsMultipleEdgesResolveMode
    def __init__(self) -> None:
        ...
    @property
    def makeDegenerateBand(self) -> bool:
        """
        If true creates degenerate faces band around hole to have sharp angle visualization
        warning: This flag bad for result topology, most likely you do not need it
        """
    @makeDegenerateBand.setter
    def makeDegenerateBand(self, arg0: bool) -> None:
        ...
    @property
    def maxPolygonSubdivisions(self) -> int:
        """
        The maximum number of polygon subdivisions on a triangle and two smaller polygons,
        must be 2 or larger
        """
    @maxPolygonSubdivisions.setter
    def maxPolygonSubdivisions(self, arg0: int) -> None:
        ...
    @property
    def metric(self) -> FillHoleMetric:
        """
        Specifies triangulation metric
        default for fillHole: getCircumscribedFillMetric
        """
    @metric.setter
    def metric(self, arg0: FillHoleMetric) -> None:
        ...
    @property
    def outNewFaces(self) -> FaceBitSet:
        """
        If not nullptr accumulate new faces
        """
    @outNewFaces.setter
    def outNewFaces(self, arg0: FaceBitSet) -> None:
        ...
class FillHoleParamsMultipleEdgesResolveMode:
    """
    Members:
    
      None : do not avoid multiple edges
    
      Simple : avoid creating edges that already exist in topology (default)
    
      Strong : makes additional efforts to avoid creating multiple edges,
    in some rare cases it is not possible (cases with extremely bad topology),
    if you faced one try to use duplicateMultiHoleVertices before fillHole
    """
    None: typing.ClassVar[FillHoleParamsMultipleEdgesResolveMode]  # value = <FillHoleParamsMultipleEdgesResolveMode.None: 0>
    Simple: typing.ClassVar[FillHoleParamsMultipleEdgesResolveMode]  # value = <FillHoleParamsMultipleEdgesResolveMode.Simple: 1>
    Strong: typing.ClassVar[FillHoleParamsMultipleEdgesResolveMode]  # value = <FillHoleParamsMultipleEdgesResolveMode.Strong: 2>
    __members__: typing.ClassVar[dict[str, FillHoleParamsMultipleEdgesResolveMode]]  # value = {'None': <FillHoleParamsMultipleEdgesResolveMode.None: 0>, 'Simple': <FillHoleParamsMultipleEdgesResolveMode.Simple: 1>, 'Strong': <FillHoleParamsMultipleEdgesResolveMode.Strong: 2>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class FindOverhangsSettings:
    """
    parameters for findOverhangs
    """
    def __init__(self) -> None:
        ...
    @property
    def axis(self) -> Vector3f:
        """
        base axis marking the up direction
        """
    @axis.setter
    def axis(self, arg0: Vector3f) -> None:
        ...
    @property
    def hops(self) -> int:
        """
        number of hops used to smooth out the overhang regions (0 - disable smoothing)
        """
    @hops.setter
    def hops(self, arg0: int) -> None:
        ...
    @property
    def layerHeight(self) -> float:
        """
        height of a layer
        """
    @layerHeight.setter
    def layerHeight(self, arg0: float) -> None:
        ...
    @property
    def maxOverhangDistance(self) -> float:
        """
        maximum overhang distance within a layer
        """
    @maxOverhangDistance.setter
    def maxOverhangDistance(self, arg0: float) -> None:
        ...
    @property
    def xf(self) -> AffineXf3f:
        """
        mesh transform
        """
    @xf.setter
    def xf(self, arg0: AffineXf3f) -> None:
        ...
class FloatGrid:
    """
    Smart pointer to OpenVdbFloatGrid
    """
    def __init__(self) -> None:
        ...
class GeneralOffsetParameters(SharpOffsetParameters):
    """
    allows the user to select in the parameters which offset algorithm to call
    """
    mode: GeneralOffsetParametersMode
    def __init__(self) -> None:
        ...
class GeneralOffsetParametersMode:
    """
    Members:
    
      Smooth : create mesh using dual marching cubes from OpenVDB library
    
      Standard : create mesh using standard marching cubes implemented in MeshLib
    
      Sharpening : create mesh using standard marching cubes with additional sharpening implemented in MeshLib
    """
    Sharpening: typing.ClassVar[GeneralOffsetParametersMode]  # value = <GeneralOffsetParametersMode.Sharpening: 2>
    Smooth: typing.ClassVar[GeneralOffsetParametersMode]  # value = <GeneralOffsetParametersMode.Smooth: 0>
    Standard: typing.ClassVar[GeneralOffsetParametersMode]  # value = <GeneralOffsetParametersMode.Standard: 1>
    __members__: typing.ClassVar[dict[str, GeneralOffsetParametersMode]]  # value = {'Smooth': <GeneralOffsetParametersMode.Smooth: 0>, 'Standard': <GeneralOffsetParametersMode.Standard: 1>, 'Sharpening': <GeneralOffsetParametersMode.Sharpening: 2>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class GeodesicPathApprox:
    """
    Method of approximation
    
    Members:
    
      DijkstraBiDir : Bidirectional Dijkstra algorithm
    
      DijkstraAStar : Dijkstra algorithm with A* modification
    
      FastMarching : Fast marching algorithm
    """
    DijkstraAStar: typing.ClassVar[GeodesicPathApprox]  # value = <GeodesicPathApprox.DijkstraAStar: 1>
    DijkstraBiDir: typing.ClassVar[GeodesicPathApprox]  # value = <GeodesicPathApprox.DijkstraBiDir: 0>
    FastMarching: typing.ClassVar[GeodesicPathApprox]  # value = <GeodesicPathApprox.FastMarching: 2>
    __members__: typing.ClassVar[dict[str, GeodesicPathApprox]]  # value = {'DijkstraBiDir': <GeodesicPathApprox.DijkstraBiDir: 0>, 'DijkstraAStar': <GeodesicPathApprox.DijkstraAStar: 1>, 'FastMarching': <GeodesicPathApprox.FastMarching: 2>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class GridType:
    """
    Members:
    
      DenseGrid : Represents dense volume
    
      LevelSet : Represents distances volume
    """
    DenseGrid: typing.ClassVar[GridType]  # value = <GridType.DenseGrid: 0>
    LevelSet: typing.ClassVar[GridType]  # value = <GridType.LevelSet: 1>
    __members__: typing.ClassVar[dict[str, GridType]]  # value = {'DenseGrid': <GridType.DenseGrid: 0>, 'LevelSet': <GridType.LevelSet: 1>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class HolesVertIds:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: vectorVerts) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: HolesVertIds) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> HolesVertIds:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> vectorVerts:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: HolesVertIds) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: HolesVertIds) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: vectorVerts) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: HolesVertIds) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: vectorVerts) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: vectorVerts) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: HolesVertIds) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: vectorVerts) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> vectorVerts:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> vectorVerts:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: vectorVerts) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class ICP:
    """
    This class allows to match two meshes with almost same geometry throw ICP point-to-point or point-to-plane algorithms
    """
    @typing.overload
    def __init__(self, floatingMesh: Mesh, referenceMesh: Mesh, fltMeshXf: AffineXf3f, refMeshXf: AffineXf3f, floatingMeshBitSet: VertBitSet) -> None:
        """
        xf parameters should represent current transformations of meshes
        fltMeshXf - transform from the local floatingMesh basis to the global
        refMeshXf - transform from the local referenceMesh basis to the global
        floatingMeshBitSet - allows to take exact set of vertices from the mesh
        """
    @typing.overload
    def __init__(self, floatingMesh: Mesh, referenceMesh: Mesh, fltMeshXf: AffineXf3f, refMeshXf: AffineXf3f, floatSamplingVoxelSize: float) -> None:
        """
        xf parameters should represent current transformations of meshes
        fltMeshXf - transform from the local floatingMesh basis to the global
        refMeshXf - transform from the local referenceMesh basis to the global
        floatSamplingVoxelSize = positive value here defines voxel size, and only one vertex per voxel will be selected
        """
    def autoSelectFloatXf(self) -> AffineXf3f:
        """
        automatically selects initial transformation for the floating object based on covariance matrices of both floating and reference objects; applies the transformation to the floating object and returns it
        """
    def calculateTransformation(self) -> AffineXf3f:
        """
        returns new xf transformation for the floating mesh, which allows to match reference mesh
        """
    def getDistLimitsSq(self) -> tuple[float, float]:
        """
        finds squared minimum and maximum pairs distances
        """
    def getLastICPInfo(self) -> str:
        """
        returns status info string
        """
    def getMeanSqDistToPlane(self) -> float:
        """
        computes root-mean-square deviation from points to target planes
        """
    def getMeanSqDistToPoint(self) -> float:
        """
        computes root-mean-square deviation between points
        """
    def getParams(self) -> ICPProperties:
        ...
    def getShiftVector(self) -> Vector3f:
        """
        shows mean pair vector
        """
    def getVertPairs(self) -> vectorICPVertPair:
        """
        used to visualize generated points pairs
        """
    def recomputeBitSet(self, floatSamplingVoxelSize: float) -> None:
        ...
    def setBadIterCount(self, iter: int) -> None:
        ...
    def setCosineLimit(self, cos: float) -> None:
        ...
    def setDistanceFilterSigmaFactor(self, factor: float) -> None:
        ...
    def setDistanceLimit(self, dist: float) -> None:
        ...
    def setPairsWeight(self, v: vectorFloat) -> None:
        ...
    def setParams(self, prop: ICPProperties) -> None:
        """
        tune algirithm params before run calculateTransformation()
        """
    def updateVertPairs(self) -> None:
        """
        recompute point pairs after manual change of transformations or parameters
        """
class ICPMethod:
    """
    The method how to update transformation from point pairs
    
    Members:
    
      Combined : PointToPoint for the first 2 iterations, and PointToPlane for the remaining iterations
    
      PointToPoint : select transformation that minimizes mean squared distance between two points in each pair, it is the safest approach but can converge slowly
    
      PointToPlane : select transformation that minimizes mean squared distance between a point and a plane via the other point in each pair, converge much faster than PointToPoint in case of many good (with not all points/normals in one plane) pairs
    """
    Combined: typing.ClassVar[ICPMethod]  # value = <ICPMethod.Combined: 0>
    PointToPlane: typing.ClassVar[ICPMethod]  # value = <ICPMethod.PointToPlane: 2>
    PointToPoint: typing.ClassVar[ICPMethod]  # value = <ICPMethod.PointToPoint: 1>
    __members__: typing.ClassVar[dict[str, ICPMethod]]  # value = {'Combined': <ICPMethod.Combined: 0>, 'PointToPoint': <ICPMethod.PointToPoint: 1>, 'PointToPlane': <ICPMethod.PointToPlane: 2>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class ICPMode:
    """
    The group of transformations, each with its own degrees of freedom
    
    Members:
    
      RigidScale : rigid body transformation with uniform scaling (7 degrees of freedom)
    
      AnyRigidXf : rigid body transformation (6 degrees of freedom)
    
      OrthogonalAxis : rigid body transformation with rotation except argument axis (5 degrees of freedom)
    
      FixedAxis : rigid body transformation with rotation around given axis only (4 degrees of freedom)
    
      TranslationOnly : only translation (3 degrees of freedom)
    """
    AnyRigidXf: typing.ClassVar[ICPMode]  # value = <ICPMode.AnyRigidXf: 1>
    FixedAxis: typing.ClassVar[ICPMode]  # value = <ICPMode.FixedAxis: 3>
    OrthogonalAxis: typing.ClassVar[ICPMode]  # value = <ICPMode.OrthogonalAxis: 2>
    RigidScale: typing.ClassVar[ICPMode]  # value = <ICPMode.RigidScale: 0>
    TranslationOnly: typing.ClassVar[ICPMode]  # value = <ICPMode.TranslationOnly: 4>
    __members__: typing.ClassVar[dict[str, ICPMode]]  # value = {'RigidScale': <ICPMode.RigidScale: 0>, 'AnyRigidXf': <ICPMode.AnyRigidXf: 1>, 'OrthogonalAxis': <ICPMode.OrthogonalAxis: 2>, 'FixedAxis': <ICPMode.FixedAxis: 3>, 'TranslationOnly': <ICPMode.TranslationOnly: 4>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class ICPProperties:
    def __init__(self) -> None:
        ...
    @property
    def badIterStopCount(self) -> int:
        """
        maximum iterations without improvements
        """
    @badIterStopCount.setter
    def badIterStopCount(self, arg0: int) -> None:
        ...
    @property
    def cosTreshold(self) -> float:
        """
        Points pair will be counted only if cosine between surface normals in points is higher
        """
    @cosTreshold.setter
    def cosTreshold(self, arg0: float) -> None:
        ...
    @property
    def distStatisticSigmaFactor(self) -> float:
        """
        Sigma multiplier for statistic throw of paints pair based on the distance
        Default: all pairs in the interval the (distance = mean +- 3*sigma) are passed
        """
    @distStatisticSigmaFactor.setter
    def distStatisticSigmaFactor(self, arg0: float) -> None:
        ...
    @property
    def distTresholdSq(self) -> float:
        """
        Points pair will be counted only if squared distance between points is lower than
        """
    @distTresholdSq.setter
    def distTresholdSq(self, arg0: float) -> None:
        ...
    @property
    def exitVal(self) -> float:
        """
        Algorithm target root-mean-square distance. As soon as it is reached, the algorithm stops.
        """
    @exitVal.setter
    def exitVal(self, arg0: float) -> None:
        ...
    @property
    def fixedRotationAxis(self) -> Vector3f:
        """
        If this vector is not zero then rotation is allowed relative to this axis only
        """
    @fixedRotationAxis.setter
    def fixedRotationAxis(self, arg0: Vector3f) -> None:
        ...
    @property
    def freezePairs(self) -> bool:
        """
        keep point pairs from first iteration
        """
    @freezePairs.setter
    def freezePairs(self, arg0: bool) -> None:
        ...
    @property
    def icpMode(self) -> ICPMode:
        """
        Finds only translation. Rotation part is identity matrix
        """
    @icpMode.setter
    def icpMode(self, arg0: ICPMode) -> None:
        ...
    @property
    def iterLimit(self) -> int:
        """
        maximum iterations
        """
    @iterLimit.setter
    def iterLimit(self, arg0: int) -> None:
        ...
    @property
    def method(self) -> ICPMethod:
        """
        The method how to update transformation from point pairs
        """
    @method.setter
    def method(self, arg0: ICPMethod) -> None:
        ...
    @property
    def p2plAngleLimit(self) -> float:
        """
        Rotation angle during one iteration of PointToPlane will be limited by this value
        """
    @p2plAngleLimit.setter
    def p2plAngleLimit(self, arg0: float) -> None:
        ...
    @property
    def p2plScaleLimit(self) -> float:
        """
        Scaling during one iteration of PointToPlane will be limited by this value
        """
    @p2plScaleLimit.setter
    def p2plScaleLimit(self, arg0: float) -> None:
        ...
class IntersectionPrecomputesd:
    """
    stores useful precomputed values for presented direction vector
    allows to avoid repeatable computations during intersection finding
    """
    def __init__(self, dir: Vector3d) -> None:
        ...
class IntersectionPrecomputesf:
    """
    stores useful precomputed values for presented direction vector
    allows to avoid repeatable computations during intersection finding
    """
    def __init__(self, dir: Vector3f) -> None:
        ...
class LaplacianEdgeWeightsParam:
    """
    Members:
    
      Unit : all edges have same weight=1
    
      Cotan : edge weight depends on local geometry and uses cotangent values
    
      CotanTimesLength : edge weight is equal to edge length times cotangent weight
    """
    Cotan: typing.ClassVar[LaplacianEdgeWeightsParam]  # value = <LaplacianEdgeWeightsParam.Cotan: 1>
    CotanTimesLength: typing.ClassVar[LaplacianEdgeWeightsParam]  # value = <LaplacianEdgeWeightsParam.CotanTimesLength: 2>
    Unit: typing.ClassVar[LaplacianEdgeWeightsParam]  # value = <LaplacianEdgeWeightsParam.Unit: 0>
    __members__: typing.ClassVar[dict[str, LaplacianEdgeWeightsParam]]  # value = {'Unit': <LaplacianEdgeWeightsParam.Unit: 0>, 'Cotan': <LaplacianEdgeWeightsParam.Cotan: 1>, 'CotanTimesLength': <LaplacianEdgeWeightsParam.CotanTimesLength: 2>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class Line3d:
    """
    3-dimensional line: cross( x - p, d ) = 0
    """
    d: Vector3d
    p: Vector3d
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, p: Vector3d, d: Vector3d) -> None:
        ...
    def distanceSq(self, x: Vector3d) -> float:
        """
        returns squared distance from given point to this line
        """
    def normalized(self) -> Line3d:
        """
        returns same line represented with unit d-vector
        """
    def project(self, x: Vector3d) -> Vector3d:
        """
        finds the closest point on line
        """
class Line3f:
    """
    3-dimensional line: cross( x - p, d ) = 0
    """
    d: Vector3f
    p: Vector3f
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, p: Vector3f, d: Vector3f) -> None:
        ...
    def distanceSq(self, x: Vector3f) -> float:
        """
        returns squared distance from given point to this line
        """
    def normalized(self) -> Line3f:
        """
        returns same line represented with unit d-vector
        """
    def project(self, x: Vector3f) -> Vector3f:
        """
        finds the closest point on line
        """
class LineSegm2f:
    """
    a segment of 2-dimensional line
    """
    a: Vector2f
    b: Vector2f
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: Vector2f, arg1: Vector2f) -> None:
        ...
class LineSegm3f:
    """
    a segment of 3-dimensional line
    """
    a: Vector3f
    b: Vector3f
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: Vector3f, arg1: Vector3f) -> None:
        ...
class LoadDCMResult:
    name: str
    vdbVolume: VdbVolume
    xf: AffineXf3f
class LoadDCMResults:
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, s: slice) -> LoadDCMResults:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> LoadDCMResult:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: LoadDCMResults) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: LoadDCMResult) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: LoadDCMResults) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: LoadDCMResult) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: LoadDCMResults) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: LoadDCMResult) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> LoadDCMResult:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> LoadDCMResult:
        """
        Remove and return the item at index ``i``
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class LoadingTiffSettings:
    """
    Settings structure for loadTiffDir function
    """
    def __init__(self) -> None:
        ...
    @property
    def dir(self) -> Path:
        """
        Path to directory
        """
    @dir.setter
    def dir(self, arg0: Path) -> None:
        ...
    @property
    def gridType(self) -> GridType:
        """
        Type of the grid: DenseGrid or LevelSet
        """
    @gridType.setter
    def gridType(self, arg0: GridType) -> None:
        ...
    @property
    def progressCallback(self) -> typing.Callable[[float], bool]:
        """
        Callback to report progress
        """
    @progressCallback.setter
    def progressCallback(self, arg0: typing.Callable[[float], bool]) -> None:
        ...
    @property
    def voxelSize(self) -> Vector3f:
        """
        Size of voxel
        """
    @voxelSize.setter
    def voxelSize(self, arg0: Vector3f) -> None:
        ...
class Matrix2d:
    """
    arbitrary 2x2 matrix
    """
    __hash__: typing.ClassVar[None] = None
    y: Vector2d
    @staticmethod
    @typing.overload
    def rotation(angle: float) -> Matrix2d:
        """
        creates matrix representing rotation around origin on given angle
        """
    @staticmethod
    @typing.overload
    def rotation(from: Vector2d, to: Vector2d) -> Matrix2d:
        """
        creates matrix representing rotation that after application to (from) makes (to) vector
        """
    @staticmethod
    @typing.overload
    def scale(s: float) -> Matrix2d:
        """
        returns a matrix that scales uniformly
        """
    @staticmethod
    @typing.overload
    def scale(x: float, y: float) -> Matrix2d:
        """
        returns a matrix that has its own scale along each axis
        """
    @staticmethod
    def zero() -> Matrix2d:
        ...
    def __add__(self, arg0: Matrix2d) -> Matrix2d:
        ...
    def __eq__(self, arg0: Matrix2d) -> bool:
        ...
    def __iadd__(self, arg0: Matrix2d) -> Matrix2d:
        ...
    def __imul__(self, arg0: float) -> Matrix2d:
        ...
    def __init__(self) -> None:
        ...
    def __isub__(self, arg0: Matrix2d) -> Matrix2d:
        ...
    def __itruediv__(self, arg0: float) -> Matrix2d:
        ...
    @typing.overload
    def __mul__(self, arg0: float) -> Matrix2d:
        ...
    @typing.overload
    def __mul__(self, arg0: Vector2d) -> Vector2d:
        ...
    @typing.overload
    def __mul__(self, arg0: Matrix2d) -> Matrix2d:
        ...
    def __rmul__(self, arg0: float) -> Matrix2d:
        ...
    def __sub__(self, arg0: Matrix2d) -> Matrix2d:
        ...
    def __truediv__(self, arg0: float) -> Matrix2d:
        ...
    def det(self) -> float:
        """
        computes determinant of the matrix
        """
    def inverse(self) -> Matrix2d:
        """
        computes inverse matrix
        """
    def norm(self) -> float:
        ...
    def normSq(self) -> float:
        """
        compute sum of squared matrix elements
        """
    def transposed(self) -> Matrix2d:
        """
        computes transposed matrix
        """
    @property
    def x(self) -> Vector2d:
        """
        rows, identity matrix by default
        """
    @x.setter
    def x(self, arg0: Vector2d) -> None:
        ...
class Matrix2f:
    """
    arbitrary 2x2 matrix
    """
    __hash__: typing.ClassVar[None] = None
    y: Vector2f
    @staticmethod
    @typing.overload
    def rotation(angle: float) -> Matrix2f:
        """
        creates matrix representing rotation around origin on given angle
        """
    @staticmethod
    @typing.overload
    def rotation(from: Vector2f, to: Vector2f) -> Matrix2f:
        """
        creates matrix representing rotation that after application to (from) makes (to) vector
        """
    @staticmethod
    @typing.overload
    def scale(s: float) -> Matrix2f:
        """
        returns a matrix that scales uniformly
        """
    @staticmethod
    @typing.overload
    def scale(x: float, y: float) -> Matrix2f:
        """
        returns a matrix that has its own scale along each axis
        """
    @staticmethod
    def zero() -> Matrix2f:
        ...
    def __add__(self, arg0: Matrix2f) -> Matrix2f:
        ...
    def __eq__(self, arg0: Matrix2f) -> bool:
        ...
    def __iadd__(self, arg0: Matrix2f) -> Matrix2f:
        ...
    def __imul__(self, arg0: float) -> Matrix2f:
        ...
    def __init__(self) -> None:
        ...
    def __isub__(self, arg0: Matrix2f) -> Matrix2f:
        ...
    def __itruediv__(self, arg0: float) -> Matrix2f:
        ...
    @typing.overload
    def __mul__(self, arg0: float) -> Matrix2f:
        ...
    @typing.overload
    def __mul__(self, arg0: Vector2f) -> Vector2f:
        ...
    @typing.overload
    def __mul__(self, arg0: Matrix2f) -> Matrix2f:
        ...
    def __rmul__(self, arg0: float) -> Matrix2f:
        ...
    def __sub__(self, arg0: Matrix2f) -> Matrix2f:
        ...
    def __truediv__(self, arg0: float) -> Matrix2f:
        ...
    def det(self) -> float:
        """
        computes determinant of the matrix
        """
    def inverse(self) -> Matrix2f:
        """
        computes inverse matrix
        """
    def norm(self) -> float:
        ...
    def normSq(self) -> float:
        """
        compute sum of squared matrix elements
        """
    def transposed(self) -> Matrix2f:
        """
        computes transposed matrix
        """
    @property
    def x(self) -> Vector2f:
        """
        rows, identity matrix by default
        """
    @x.setter
    def x(self, arg0: Vector2f) -> None:
        ...
class Matrix3d:
    """
    arbitrary 3x3 matrix
    """
    __hash__: typing.ClassVar[None] = None
    y: Vector3d
    z: Vector3d
    @staticmethod
    @typing.overload
    def rotation(axis: Vector3d, angle: float) -> Matrix3d:
        """
        creates matrix representing rotation around given axis on given angle
        """
    @staticmethod
    @typing.overload
    def rotation(from: Vector3d, to: Vector3d) -> Matrix3d:
        """
        creates matrix representing rotation that after application to (from) makes (to) vector
        """
    @staticmethod
    def rotationFromEuler(eulerAngles: Vector3d) -> Matrix3d:
        """
        creates matrix representing rotation from 3 Euler angles: R=R(z)*R(y)*R(x)
        see more https://en.wikipedia.org/wiki/Euler_angles#Conventions_by_intrinsic_rotations
        """
    @staticmethod
    @typing.overload
    def scale(s: float) -> Matrix3d:
        """
        returns a matrix that scales uniformly
        """
    @staticmethod
    @typing.overload
    def scale(x: float, y: float, z: float) -> Matrix3d:
        """
        returns a matrix that has its own scale along each axis
        """
    @staticmethod
    def zero() -> Matrix3d:
        ...
    def __add__(self, arg0: Matrix3d) -> Matrix3d:
        ...
    def __eq__(self, arg0: Matrix3d) -> bool:
        ...
    def __iadd__(self, arg0: Matrix3d) -> Matrix3d:
        ...
    def __imul__(self, arg0: float) -> Matrix3d:
        ...
    def __init__(self) -> None:
        ...
    def __isub__(self, arg0: Matrix3d) -> Matrix3d:
        ...
    def __itruediv__(self, arg0: float) -> Matrix3d:
        ...
    @typing.overload
    def __mul__(self, arg0: float) -> Matrix3d:
        ...
    @typing.overload
    def __mul__(self, arg0: Vector3d) -> Vector3d:
        ...
    @typing.overload
    def __mul__(self, arg0: Matrix3d) -> Matrix3d:
        ...
    def __rmul__(self, arg0: float) -> Matrix3d:
        ...
    def __sub__(self, arg0: Matrix3d) -> Matrix3d:
        ...
    def __truediv__(self, arg0: float) -> Matrix3d:
        ...
    def det(self) -> float:
        """
        computes determinant of the matrix
        """
    def inverse(self) -> Matrix3d:
        """
        computes inverse matrix
        """
    def norm(self) -> float:
        ...
    def normSq(self) -> float:
        """
        compute sum of squared matrix elements
        """
    def toEulerAngles(self) -> Vector3d:
        """
        returns 3 Euler angles, assuming this is a rotation matrix composed as follows: R=R(z)*R(y)*R(x)
        """
    def transposed(self) -> Matrix3d:
        """
        computes transposed matrix
        """
    @property
    def x(self) -> Vector3d:
        """
        rows, identity matrix by default
        """
    @x.setter
    def x(self, arg0: Vector3d) -> None:
        ...
class Matrix3f:
    """
    arbitrary 3x3 matrix
    """
    __hash__: typing.ClassVar[None] = None
    y: Vector3f
    z: Vector3f
    @staticmethod
    @typing.overload
    def rotation(axis: Vector3f, angle: float) -> Matrix3f:
        """
        creates matrix representing rotation around given axis on given angle
        """
    @staticmethod
    @typing.overload
    def rotation(from: Vector3f, to: Vector3f) -> Matrix3f:
        """
        creates matrix representing rotation that after application to (from) makes (to) vector
        """
    @staticmethod
    def rotationFromEuler(eulerAngles: Vector3f) -> Matrix3f:
        """
        creates matrix representing rotation from 3 Euler angles: R=R(z)*R(y)*R(x)
        see more https://en.wikipedia.org/wiki/Euler_angles#Conventions_by_intrinsic_rotations
        """
    @staticmethod
    @typing.overload
    def scale(s: float) -> Matrix3f:
        """
        returns a matrix that scales uniformly
        """
    @staticmethod
    @typing.overload
    def scale(x: float, y: float, z: float) -> Matrix3f:
        """
        returns a matrix that has its own scale along each axis
        """
    @staticmethod
    def zero() -> Matrix3f:
        ...
    def __add__(self, arg0: Matrix3f) -> Matrix3f:
        ...
    def __eq__(self, arg0: Matrix3f) -> bool:
        ...
    def __iadd__(self, arg0: Matrix3f) -> Matrix3f:
        ...
    def __imul__(self, arg0: float) -> Matrix3f:
        ...
    def __init__(self) -> None:
        ...
    def __isub__(self, arg0: Matrix3f) -> Matrix3f:
        ...
    def __itruediv__(self, arg0: float) -> Matrix3f:
        ...
    @typing.overload
    def __mul__(self, arg0: float) -> Matrix3f:
        ...
    @typing.overload
    def __mul__(self, arg0: Vector3f) -> Vector3f:
        ...
    @typing.overload
    def __mul__(self, arg0: Matrix3f) -> Matrix3f:
        ...
    def __rmul__(self, arg0: float) -> Matrix3f:
        ...
    def __sub__(self, arg0: Matrix3f) -> Matrix3f:
        ...
    def __truediv__(self, arg0: float) -> Matrix3f:
        ...
    def det(self) -> float:
        """
        computes determinant of the matrix
        """
    def inverse(self) -> Matrix3f:
        """
        computes inverse matrix
        """
    def norm(self) -> float:
        ...
    def normSq(self) -> float:
        """
        compute sum of squared matrix elements
        """
    def toEulerAngles(self) -> Vector3f:
        """
        returns 3 Euler angles, assuming this is a rotation matrix composed as follows: R=R(z)*R(y)*R(x)
        """
    def transposed(self) -> Matrix3f:
        """
        computes transposed matrix
        """
    @property
    def x(self) -> Vector3f:
        """
        rows, identity matrix by default
        """
    @x.setter
    def x(self, arg0: Vector3f) -> None:
        ...
class Mesh:
    __hash__: typing.ClassVar[None] = None
    points: VertCoords
    topology: MeshTopology
    def __eq__(self, arg0: Mesh) -> bool:
        """
        compare that two meshes are exactly the same
        """
    def __init__(self) -> None:
        ...
    def addPartByMask(self, from: Mesh, fromFaces: FaceBitSet = None, map: PartMapping = ...) -> None:
        """
        appends mesh (from) in addition to this mesh: creates new edges, faces, verts and points
        copies only portion of (from) specified by fromFaces
        """
    def area(self, fs: FaceBitSet = None) -> float:
        """
        this version returns the area of whole mesh if argument is nullptr
        """
    def computeBoundingBox(self, region: FaceBitSet = None, toWorld: AffineXf3f = None) -> Box3f:
        """
        passes through all given faces (or whole mesh if region == null) and finds the minimal bounding box containing all of them
        if toWorld transformation is given then returns minimal bounding box in world space
        """
    def discreteMeanCurvature(self, v: VertId) -> float:
        """
        computes discrete mean curvature in given vertex measures in length^-1;
        0 for planar regions, positive for convex surface, negative for concave surface
        """
    def edgePoint(self, ep: EdgePoint) -> Vector3f:
        """
        returns a point on the edge: origin point for f=0 and destination point for f=1
        """
    def getBoundingBox(self) -> Box3f:
        """
        returns the bounding box containing all valid vertices (implemented via getAABBTree())
        this bounding box is insignificantly bigger that minimal box due to AABB algorithms precision
        """
    def invalidateCaches(self, pointsChanged: bool = True) -> None:
        """
        Invalidates caches (e.g. aabb-tree) after a change in mesh geometry or topology
        """
    def pack(self, outFmap: FaceMap = None, outVmap: VertMap = None, outEmap: WholeEdgeMap = None, rearrangeTriangles: bool = False) -> None:
        """
        tightly packs all arrays eliminating lone edges and invalid face, verts and points,
        optionally returns mappings: old.id -> new.id
        """
    def packOptimally(self, preserveAABBTree: bool = True) -> PackMapping:
        """
        packs tightly and rearranges vertices, triangles and edges to put close in space elements in close indices
        	preserveAABBTree whether to keep valid mesh's AABB tree after return (it will take longer to compute and it will occupy more memory)
        """
    @typing.overload
    def splitEdge(self, e: EdgeId, newVertPos: Vector3f, region: FaceBitSet = None, new2Old: FaceHashMap = None) -> EdgeId:
        """
        split given edge on two parts:
        dest(returned-edge) = org(e) - newly created vertex,
        org(returned-edge) = org(e-before-split),
        dest(e) = dest(e-before-split)
        	left and right faces of given edge if valid are also subdivided on two parts each;
        	if left or right faces of the original edge were in the region, then include new parts of these faces in the region
        	new2Old - receive mapping from newly appeared triangle to its original triangle (part to full)
        """
    @typing.overload
    def splitEdge(self, e: EdgeId, region: FaceBitSet = None, new2Old: FaceHashMap = None) -> EdgeId:
        """
        split given edge on two equal parts:
        dest(returned-edge) = org(e) - newly created vertex,
        org(returned-edge) = org(e-before-split),
        dest(e) = dest(e-before-split)
        	left and right faces of given edge if valid are also subdivided on two parts each;
        	if left or right faces of the original edge were in the region, then include new parts of these faces in the region
        	new2Old - receive mapping from newly appeared triangle to its original triangle (part to full)
        """
    @typing.overload
    def splitFace(self, f: FaceId, newVertPos: Vector3f, region: FaceBitSet = None, new2Old: FaceHashMap = None) -> VertId:
        """
        split given triangle on three triangles, introducing new vertex with given coordinates and connecting it to original triangle vertices;
        if region is given, then it must include (f) and new faces will be added there as well
        	new2Old receive mapping from newly appeared triangle to its original triangle (part to full)
        """
    @typing.overload
    def splitFace(self, f: FaceId, region: FaceBitSet = None, new2Old: FaceHashMap = None) -> VertId:
        """
        split given triangle on three triangles, introducing new vertex in the centroid of original triangle and connecting it to original triangle vertices;
        if region is given, then it must include (f) and new faces will be added there as well
        	new2Old receive mapping from newly appeared triangle to its original triangle (part to full)
        """
    def transform(self, xf: AffineXf3f, region: VertBitSet = None) -> None:
        """
        applies given transformation to specified vertices
        if region is nullptr, all valid mesh vertices are used
        """
    def triPoint(self, p: MeshTriPoint) -> Vector3f:
        """
        returns interpolated coordinates of given point
        """
    def volume(self, region: FaceBitSet = None) -> float:
        """
        returns volume of closed mesh region, if region is not closed DBL_MAX is returned
        if region is nullptr - whole mesh is region
        """
class MeshBuilderSettings:
    def __init__(self) -> None:
        ...
    @property
    def allowNonManifoldEdge(self) -> bool:
        """
        whether to permit non-manifold edges in the resulting topology
        """
    @allowNonManifoldEdge.setter
    def allowNonManifoldEdge(self, arg0: bool) -> None:
        ...
    @property
    def region(self) -> FaceBitSet:
        """
        if region is given then on input it contains the faces to be added, and on output the faces failed to be added
        """
    @region.setter
    def region(self, arg0: FaceBitSet) -> None:
        ...
    @property
    def shiftFaceId(self) -> int:
        """
        this value to be added to every faceId before its inclusion in the topology
        """
    @shiftFaceId.setter
    def shiftFaceId(self, arg0: int) -> None:
        ...
class MeshIntersectionResult:
    def __init__(self) -> None:
        ...
    @property
    def distanceAlongLine(self) -> float:
        """
        stores the distance from ray origin to the intersection point in direction units
        """
    @distanceAlongLine.setter
    def distanceAlongLine(self, arg0: float) -> None:
        ...
    @property
    def mtp(self) -> MeshTriPoint:
        """
        stores barycentric coordinates
        """
    @mtp.setter
    def mtp(self, arg0: MeshTriPoint) -> None:
        ...
    @property
    def proj(self) -> PointOnFace:
        """
        stores intersected face and global coordinates
        """
    @proj.setter
    def proj(self, arg0: PointOnFace) -> None:
        ...
class MeshLoadSettings:
    """
    mesh load settings
    """
    callback: typing.Callable[[float], bool]
    colors: VertColorMap
    duplicatedVertexCount: int
    skippedFaceCount: int
    xf: AffineXf3f
    def __init__(self) -> None:
        ...
class MeshPart:
    """
    stores reference on whole mesh (if region is nullptr) or on its part (if region pointer is valid)
    """
    def __init__(self, mesh: Mesh, region: FaceBitSet = None) -> None:
        ...
    @property
    def region(self) -> FaceBitSet:
        """
        nullptr here means whole mesh
        """
    @region.setter
    def region(self, arg0: FaceBitSet) -> None:
        ...
class MeshProjectionResult:
    def __init__(self) -> None:
        ...
    @property
    def distSq(self) -> float:
        """
        squared distance from pt to proj
        """
    @distSq.setter
    def distSq(self, arg0: float) -> None:
        ...
    @property
    def mtp(self) -> MeshTriPoint:
        """
        its barycentric representation
        """
    @mtp.setter
    def mtp(self, arg0: MeshTriPoint) -> None:
        ...
    @property
    def proj(self) -> PointOnFace:
        """
        the closest point on mesh, transformed by xf if it is given
        """
    @proj.setter
    def proj(self, arg0: PointOnFace) -> None:
        ...
class MeshRelaxParams(RelaxParams):
    def __init__(self) -> None:
        ...
    @property
    def hardSmoothTetrahedrons(self) -> bool:
        """
        smooth tetrahedron verts (with complete three edges ring) to base triangle (based on its edges destinations)
        """
    @hardSmoothTetrahedrons.setter
    def hardSmoothTetrahedrons(self, arg0: bool) -> None:
        ...
class MeshSignedDistanceResult:
    def __init__(self) -> None:
        ...
    @property
    def a(self) -> PointOnFace:
        """
        two closest points: from meshes A and B respectively
        """
    @a.setter
    def a(self, arg0: PointOnFace) -> None:
        ...
    @property
    def b(self) -> PointOnFace:
        """
        two closest points: from meshes A and B respectively
        """
    @b.setter
    def b(self, arg0: PointOnFace) -> None:
        ...
    @property
    def signedDist(self) -> float:
        """
        signed distance between a and b, positive if meshes do not collide
        """
    @signedDist.setter
    def signedDist(self, arg0: float) -> None:
        ...
class MeshToDistanceMapParams:
    def __init__(self) -> None:
        """
        Default constructor. Manual params initialization is required
        """
    def setDistanceLimits(self, min: float, max: float) -> None:
        """
        if distance is not in set range, pixel became invalid
        default value: false. Any distance will be applied (include negative)
        """
    @property
    def allowNegativeValues(self) -> bool:
        """
        allows to find intersections in backward to direction vector with negative values
        """
    @allowNegativeValues.setter
    def allowNegativeValues(self, arg0: bool) -> None:
        ...
    @property
    def direction(self) -> Vector3f:
        """
        direction of intersection ray
        """
    @direction.setter
    def direction(self, arg0: Vector3f) -> None:
        ...
    @property
    def maxValue(self) -> float:
        """
        Using of this parameter depends on useDistanceLimits
        """
    @maxValue.setter
    def maxValue(self, arg0: float) -> None:
        ...
    @property
    def minValue(self) -> float:
        """
        Using of this parameter depends on useDistanceLimits
        """
    @minValue.setter
    def minValue(self, arg0: float) -> None:
        ...
    @property
    def orgPoint(self) -> Vector3f:
        """
        location of (0,0) pixel with value 0.f
        """
    @orgPoint.setter
    def orgPoint(self, arg0: Vector3f) -> None:
        ...
    @property
    def resolution(self) -> Vector2i:
        """
        resolution of distance map
        """
    @resolution.setter
    def resolution(self, arg0: Vector2i) -> None:
        ...
    @property
    def useDistanceLimits(self) -> bool:
        """
        out of limits intersections will be set to non-valid
        """
    @useDistanceLimits.setter
    def useDistanceLimits(self, arg0: bool) -> None:
        ...
    @property
    def xRange(self) -> Vector3f:
        """
        Cartesian range vector between distance map borders in X direction
        """
    @xRange.setter
    def xRange(self, arg0: Vector3f) -> None:
        ...
    @property
    def yRange(self) -> Vector3f:
        """
        Cartesian range vector between distance map borders in Y direction
        """
    @yRange.setter
    def yRange(self, arg0: Vector3f) -> None:
        ...
class MeshToDistanceVolumeParams:
    def __init__(self) -> None:
        ...
    @property
    def dimensions(self) -> Vector3i:
        """
        num voxels along each axis
        """
    @dimensions.setter
    def dimensions(self, arg0: Vector3i) -> None:
        ...
    @property
    def maxDistSq(self) -> float:
        """
        maximum squared value in a voxel
        """
    @maxDistSq.setter
    def maxDistSq(self, arg0: float) -> None:
        ...
    @property
    def minDistSq(self) -> float:
        """
        minimum squared value in a voxel
        """
    @minDistSq.setter
    def minDistSq(self, arg0: float) -> None:
        ...
    @property
    def origin(self) -> Vector3f:
        """
        origin point of voxels box
        """
    @origin.setter
    def origin(self, arg0: Vector3f) -> None:
        ...
    @property
    def signMode(self) -> SignDetectionMode:
        """
        the method to compute distance sign
        """
    @signMode.setter
    def signMode(self, arg0: SignDetectionMode) -> None:
        ...
    @property
    def voxelSize(self) -> Vector3f:
        """
        size of voxel on each axis
        """
    @voxelSize.setter
    def voxelSize(self, arg0: Vector3f) -> None:
        ...
class MeshToVolumeParams:
    """
    Parameters structure for meshToVolume function
    """
    def __init__(self) -> None:
        ...
    @property
    def outXf(self) -> AffineXf3f:
        """
        optional output: xf to original mesh (respecting worldXf)
        """
    @outXf.setter
    def outXf(self, arg0: AffineXf3f) -> None:
        ...
    @property
    def surfaceOffset(self) -> float:
        """
        the number of voxels around surface to calculate distance in (should be positive)
        """
    @surfaceOffset.setter
    def surfaceOffset(self, arg0: float) -> None:
        ...
    @property
    def type(self) -> MeshToVolumeParamsType:
        """
        Conversion type
        """
    @type.setter
    def type(self, arg0: MeshToVolumeParamsType) -> None:
        ...
    @property
    def voxelSize(self) -> Vector3f:
        """
        Conversion type
        """
    @voxelSize.setter
    def voxelSize(self, arg0: Vector3f) -> None:
        ...
    @property
    def worldXf(self) -> AffineXf3f:
        """
        mesh initial transform
        """
    @worldXf.setter
    def worldXf(self, arg0: AffineXf3f) -> None:
        ...
class MeshToVolumeParamsType:
    """
    Conversion type
    
    Members:
    
      Signed : only closed meshes can be converted with signed type
    
      Unsigned : this type leads to shell like iso-surfaces
    """
    Signed: typing.ClassVar[MeshToVolumeParamsType]  # value = <MeshToVolumeParamsType.Signed: 0>
    Unsigned: typing.ClassVar[MeshToVolumeParamsType]  # value = <MeshToVolumeParamsType.Unsigned: 1>
    __members__: typing.ClassVar[dict[str, MeshToVolumeParamsType]]  # value = {'Signed': <MeshToVolumeParamsType.Signed: 0>, 'Unsigned': <MeshToVolumeParamsType.Unsigned: 1>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class MeshTopology:
    __hash__: typing.ClassVar[None] = None
    def __eq__(self, arg0: MeshTopology) -> bool:
        """
        compare that two topologies are exactly the same
        """
    def __init__(self) -> None:
        ...
    def computeNotLoneUndirectedEdges(self) -> int:
        """
        computes the number of not-lone (valid) undirected edges
        """
    def deleteFaces(self, fs: FaceBitSet) -> None:
        """
        deletes multiple given faces
        """
    def dest(self, he: EdgeId) -> VertId:
        """
        returns destination vertex of half-edge
        """
    def edgeSize(self) -> int:
        """
        returns the number of half-edge records including lone ones
        """
    def findBoundaryEdges(self) -> EdgeBitSet:
        """
        returns all boundary edges, where each edge does not have valid left face
        """
    def findBoundaryFaces(self) -> FaceBitSet:
        """
        returns all boundary faces, having at least one boundary edge
        """
    def findBoundaryVerts(self) -> VertBitSet:
        """
        returns all boundary vertices, incident to at least one boundary edge
        """
    def findHoleRepresentiveEdges(self) -> vectorEdges:
        """
        returns one edge with no valid left face for every boundary in the mesh
        """
    @typing.overload
    def flip(self, fs: FaceBitSet) -> None:
        """
        sets in (fs) all valid faces that were not selected before the call, and resets other bits
        """
    @typing.overload
    def flip(self, vs: VertBitSet) -> None:
        """
        sets in (vs) all valid vertices that were not selected before the call, and resets other bits
        """
    def flipOrientation(self) -> None:
        """
        flip orientation (normals) of all faces
        """
    def getTriVerts(self, f: FaceId, v0: VertId, v1: VertId, v2: VertId) -> None:
        """
        gets 3 vertices of given triangular face;
        the vertices are returned in counter-clockwise order if look from mesh outside
        """
    def getValidFaces(self) -> FaceBitSet:
        """
        returns cached set of all valid faces
        """
    def getValidVerts(self) -> VertBitSet:
        """
        returns cached set of all valid vertices
        """
    def numValidFaces(self) -> int:
        """
        returns the number of valid faces
        """
    def numValidVerts(self) -> int:
        """
        returns the number of valid vertices
        """
    def org(self, he: EdgeId) -> VertId:
        """
        returns origin vertex of half-edge
        """
    def undirectedEdgeSize(self) -> int:
        """
        returns the number of undirected edges (pairs of half-edges) including lone ones
        """
class MeshTriPoint:
    """
    encodes a point inside a triangular mesh face using barycentric coordinates
    	Notations used below:
    	 v0 - the value in org( e )
    	 v1 - the value in dest( e )
    	 v2 - the value in dest( next( e ) )
    """
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, e: EdgeId, bary: TriPointf) -> None:
        ...
    @typing.overload
    def __init__(self, ep: EdgePoint) -> None:
        ...
    @typing.overload
    def __init__(self, e: EdgeId, p: Vector3f, v0: Vector3f, v1: Vector3f, v2: Vector3f) -> None:
        """
        given a point coordinates computes its barycentric coordinates
        """
    @typing.overload
    def inVertex(self, topology: MeshTopology) -> VertId:
        """
        returns valid vertex id if the point is in vertex, otherwise returns invalid id
        """
    @typing.overload
    def inVertex(self) -> bool:
        """
        returns true if the point is in a vertex
        """
    def isBd(self, topology: MeshTopology, region: FaceBitSet = None) -> bool:
        """
        returns true if the point is in vertex on on edge, and that location is on the boundary of the region
        """
    def onEdge(self, topology: MeshTopology) -> EdgePoint:
        """
        returns valid value if the point is on edge, otherwise returns null optional
        """
    @property
    def bary(self) -> TriPointf:
        """
        barycentric coordinates
        a in [0,1], a=0 => point is on next( e ) edge, a=1 => point is in dest( e )
        b in [0,1], b=0 => point is on e edge, b=1 => point is in dest( next( e ) )
        a+b in [0,1], a+b=0 => point is in org( e ), a+b=1 => point is on prev( e.sym() ) edge
        """
    @bary.setter
    def bary(self, arg0: TriPointf) -> None:
        ...
    @property
    def e(self) -> EdgeId:
        """
        left face of this edge is considered
        """
    @e.setter
    def e(self, arg0: EdgeId) -> None:
        ...
class OffsetParameters:
    """
    This struct represents parameters for offsetting with voxels conversions
    """
    def __init__(self) -> None:
        ...
    @property
    def signDetectionMode(self) -> SignDetectionMode:
        """
        The method to compute distance sign
        """
    @signDetectionMode.setter
    def signDetectionMode(self, arg0: SignDetectionMode) -> None:
        ...
    @property
    def voxelSize(self) -> float:
        """
        Size of voxel in grid conversions
        if value is not positive, it is calculated automatically (mesh bounding box is divided to 5e6 voxels)
        """
    @voxelSize.setter
    def voxelSize(self, arg0: float) -> None:
        ...
class PackMapping:
    """
    Not fully exposed, for now dummy class
    """
class PartMapping:
    """
    mapping among elements of source mesh, from which a part is taken, and target (this) mesh
    """
    def __init__(self) -> None:
        ...
    @property
    def src2tgtEdges(self) -> WholeEdgeHashMap:
        """
        from.id -> this.id
        """
    @src2tgtEdges.setter
    def src2tgtEdges(self, arg0: WholeEdgeHashMap) -> None:
        ...
    @property
    def src2tgtFaces(self) -> FaceHashMap:
        """
        from.id -> this.id
        """
    @src2tgtFaces.setter
    def src2tgtFaces(self, arg0: FaceHashMap) -> None:
        ...
    @property
    def src2tgtVerts(self) -> VertHashMap:
        """
        from.id -> this.id
        """
    @src2tgtVerts.setter
    def src2tgtVerts(self, arg0: VertHashMap) -> None:
        ...
    @property
    def tgt2srcEdges(self) -> WholeEdgeMap:
        """
        this.id -> from.id
        """
    @tgt2srcEdges.setter
    def tgt2srcEdges(self, arg0: WholeEdgeMap) -> None:
        ...
    @property
    def tgt2srcFaces(self) -> FaceMap:
        """
        this.id -> from.id
        """
    @tgt2srcFaces.setter
    def tgt2srcFaces(self, arg0: FaceMap) -> None:
        ...
    @property
    def tgt2srcVerts(self) -> VertMap:
        """
        this.id -> from.id
        """
    @tgt2srcVerts.setter
    def tgt2srcVerts(self, arg0: VertMap) -> None:
        ...
class Path:
    def __init__(self, arg0: str) -> None:
        ...
class Plane3f:
    """
    3-dimensional plane: dot(n,x) - d = 0
    """
    d: float
    n: Vector3f
    def __init__(self) -> None:
        ...
class PointCloud:
    normals: VertCoords
    points: VertCoords
    validPoints: VertBitSet
    def __init__(self) -> None:
        ...
    def getBoundingBox(self) -> Box3f:
        """
        returns the minimal bounding box containing all valid vertices (implemented via getAABBTree())
        """
    def invalidateCaches(self) -> None:
        """
        Invalidates caches (e.g. aabb-tree) after a change in point cloud
        """
class PointOnFace:
    """
    point located on some mesh face
    """
    face: FaceId
    point: Vector3f
    def __init__(self) -> None:
        ...
class Polyline2:
    points: VertCoords2
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: Contours2f) -> None:
        """
        Creates polyline from 2D contours, 3D polyline will get zero z - component
        """
    @typing.overload
    def __init__(self, arg0: Contours3f) -> None:
        """
        Creates polyline from 3D contours, 2D polyline will lose z - component
        """
    def addFromEdgePath(self, mesh: Mesh, path: vectorEdges) -> EdgeId:
        """
        Adds path to this polyline.
        Return the edge from first new to second new vertex.
        """
    @typing.overload
    def addFromPoints(self, vs: Vector2f, num: int, closed: bool) -> EdgeId:
        """
        Adds connected line in this, passing progressively via points *[vs, vs+num).
        If closed argument is true then the last and the first points will be additionally connected.
        Return the edge from first new to second new vertex.
        """
    @typing.overload
    def addFromPoints(self, vs: Vector2f, num: int) -> EdgeId:
        """
        Adds connected line in this, passing progressively via points *[vs, vs+num).
        If vs[0] == vs[num-1] then a closed line is created.
        Return the edge from first new to second new vertex.
        """
    def addFromSurfacePath(self, mesh: Mesh, path: SurfacePath) -> EdgeId:
        """
        Adds path to this polyline.
        Return the edge from first new to second new vertex.
        """
    def addPartByMask(self, from: Polyline2, mask: UndirectedEdgeBitSet, outVmap: VertMap = None, outEmap: EdgeMap = None) -> None:
        """
        Appends polyline (from) in addition to this polyline: creates new edges, faces, verts and points.
        """
    def computeBoundingBox(self, toWorld: AffineXf2f = None) -> Box2f:
        """
        Passes through all valid points and finds the minimal bounding box containing all of them.
        If toWorld transformation is given then returns minimal bounding box in world space.
        """
    def contours(self, arg0: HolesVertIds) -> Contours2f:
        """
        Convert Polyline to simple contour structures with vector of points inside.
        If all even edges are consistently oriented, then the output contours will be oriented the same.
        """
    def contours2(self, arg0: HolesVertIds) -> Contours2f:
        """
        Convert Polyline to simple 2D contour structures with vector of points inside.
        If all even edges are consistently oriented, then the output contours will be oriented the same.
        """
    def destPnt(self, e: EdgeId) -> Vector2f:
        """
        Returns coordinates of the edge destination.
        """
    def edgeCenter(self, e: EdgeId) -> Vector2f:
        """
        Returns edge's centroid.
        """
    def edgeLength(self, e: EdgeId) -> float:
        """
        Returns Euclidean length of the edge.
        """
    def edgeLengthSq(self, e: EdgeId) -> float:
        """
        Returns squared Euclidean length of the edge (faster to compute than length).
        """
    def edgePoint(self, e: EdgeId, f: float) -> Vector2f:
        """
        Returns a point on the edge: origin point for f=0 and destination point for f=1.
        """
    def edgeSegment(self, e: EdgeId) -> LineSegm2f:
        """
        Returns line segment of given edge.
        """
    def edgeVector(self, e: EdgeId) -> Vector2f:
        """
        Returns vector equal to edge destination point minus edge origin point.
        """
    def getAABBTree(self) -> AABBTreePolyline2:
        """
        Returns cached aabb-tree for this polyline, creating it if it did not exist in a thread-safe manner.
        """
    def getAABBTreeNotCreate(self) -> AABBTreePolyline2:
        """
        Returns cached aabb-tree for this polyline, but does not create it if it did not exist.
        """
    def getBoundingBox(self) -> Box2f:
        """
        Returns the minimal bounding box containing all valid vertices (implemented via getAABBTree()).
        """
    def invalidateCaches(self) -> None:
        """
        Invalidates caches (e.g. aabb-tree) after a change in polyline
        """
    def orgPnt(self, e: EdgeId) -> Vector2f:
        """
        Returns coordinates of the edge origin.
        """
    @typing.overload
    def splitEdge(self, EdgeId: EdgeId, newVertPos: Vector2f) -> EdgeId:
        """
        Split given edge on two parts:
        dest(returned-edge) = org(e) - newly created vertex,
        org(returned-edge) = org(e-before-split),
        dest(e) = dest(e-before-split)
        """
    @typing.overload
    def splitEdge(self, EdgeId: EdgeId) -> EdgeId:
        """
        Split given edge on two equal parts
        """
    @typing.overload
    def toPolyline(self) -> Polyline2:
        """
        Convert Polyline##dimension to Polyline2.
        """
    @typing.overload
    def toPolyline(self) -> Polyline3:
        """
        Convert Polyline##dimension to Polyline3.
        """
    def totalLength(self) -> float:
        """
        Returns total length of the polyline.
        """
    def transform(self, xf: AffineXf2f) -> None:
        """
        Returns the minimal bounding box containing all valid vertices (implemented via getAABBTree()).
        """
class Polyline3:
    points: VertCoords
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: Contours2f) -> None:
        """
        Creates polyline from 2D contours, 3D polyline will get zero z - component
        """
    @typing.overload
    def __init__(self, arg0: Contours3f) -> None:
        """
        Creates polyline from 3D contours, 2D polyline will lose z - component
        """
    def addFromEdgePath(self, mesh: Mesh, path: vectorEdges) -> EdgeId:
        """
        Adds path to this polyline.
        Return the edge from first new to second new vertex.
        """
    @typing.overload
    def addFromPoints(self, vs: Vector3f, num: int, closed: bool) -> EdgeId:
        """
        Adds connected line in this, passing progressively via points *[vs, vs+num).
        If closed argument is true then the last and the first points will be additionally connected.
        Return the edge from first new to second new vertex.
        """
    @typing.overload
    def addFromPoints(self, vs: Vector3f, num: int) -> EdgeId:
        """
        Adds connected line in this, passing progressively via points *[vs, vs+num).
        If vs[0] == vs[num-1] then a closed line is created.
        Return the edge from first new to second new vertex.
        """
    def addFromSurfacePath(self, mesh: Mesh, path: SurfacePath) -> EdgeId:
        """
        Adds path to this polyline.
        Return the edge from first new to second new vertex.
        """
    def addPartByMask(self, from: Polyline3, mask: UndirectedEdgeBitSet, outVmap: VertMap = None, outEmap: EdgeMap = None) -> None:
        """
        Appends polyline (from) in addition to this polyline: creates new edges, faces, verts and points.
        """
    def computeBoundingBox(self, toWorld: AffineXf3f = None) -> Box3f:
        """
        Passes through all valid points and finds the minimal bounding box containing all of them.
        If toWorld transformation is given then returns minimal bounding box in world space.
        """
    def contours(self, arg0: HolesVertIds) -> Contours3f:
        """
        Convert Polyline to simple contour structures with vector of points inside.
        If all even edges are consistently oriented, then the output contours will be oriented the same.
        """
    def contours2(self, arg0: HolesVertIds) -> Contours2f:
        """
        Convert Polyline to simple 2D contour structures with vector of points inside.
        If all even edges are consistently oriented, then the output contours will be oriented the same.
        """
    def destPnt(self, e: EdgeId) -> Vector3f:
        """
        Returns coordinates of the edge destination.
        """
    def edgeCenter(self, e: EdgeId) -> Vector3f:
        """
        Returns edge's centroid.
        """
    def edgeLength(self, e: EdgeId) -> float:
        """
        Returns Euclidean length of the edge.
        """
    def edgeLengthSq(self, e: EdgeId) -> float:
        """
        Returns squared Euclidean length of the edge (faster to compute than length).
        """
    def edgePoint(self, e: EdgeId, f: float) -> Vector3f:
        """
        Returns a point on the edge: origin point for f=0 and destination point for f=1.
        """
    def edgeSegment(self, e: EdgeId) -> LineSegm3f:
        """
        Returns line segment of given edge.
        """
    def edgeVector(self, e: EdgeId) -> Vector3f:
        """
        Returns vector equal to edge destination point minus edge origin point.
        """
    def getAABBTree(self) -> AABBTreePolyline3:
        """
        Returns cached aabb-tree for this polyline, creating it if it did not exist in a thread-safe manner.
        """
    def getAABBTreeNotCreate(self) -> AABBTreePolyline3:
        """
        Returns cached aabb-tree for this polyline, but does not create it if it did not exist.
        """
    def getBoundingBox(self) -> Box3f:
        """
        Returns the minimal bounding box containing all valid vertices (implemented via getAABBTree()).
        """
    def invalidateCaches(self) -> None:
        """
        Invalidates caches (e.g. aabb-tree) after a change in polyline
        """
    def orgPnt(self, e: EdgeId) -> Vector3f:
        """
        Returns coordinates of the edge origin.
        """
    @typing.overload
    def splitEdge(self, EdgeId: EdgeId, newVertPos: Vector3f) -> EdgeId:
        """
        Split given edge on two parts:
        dest(returned-edge) = org(e) - newly created vertex,
        org(returned-edge) = org(e-before-split),
        dest(e) = dest(e-before-split)
        """
    @typing.overload
    def splitEdge(self, EdgeId: EdgeId) -> EdgeId:
        """
        Split given edge on two equal parts
        """
    @typing.overload
    def toPolyline(self) -> Polyline2:
        """
        Convert Polyline##dimension to Polyline2.
        """
    @typing.overload
    def toPolyline(self) -> Polyline3:
        """
        Convert Polyline##dimension to Polyline3.
        """
    def totalLength(self) -> float:
        """
        Returns total length of the polyline.
        """
    def transform(self, xf: AffineXf3f) -> None:
        """
        Returns the minimal bounding box containing all valid vertices (implemented via getAABBTree()).
        """
class PolylineTopology:
    pass
class RelaxParams:
    def __init__(self) -> None:
        ...
    @property
    def force(self) -> float:
        """
        speed of relaxing, typical values (0.0, 0.5]
        """
    @force.setter
    def force(self, arg0: float) -> None:
        ...
    @property
    def iterations(self) -> int:
        """
        number of iterations
        """
    @iterations.setter
    def iterations(self, arg0: int) -> None:
        ...
    @property
    def region(self) -> VertBitSet:
        """
        region to relax
        """
    @region.setter
    def region(self, arg0: VertBitSet) -> None:
        ...
class SceneObject:
    pass
class SegmPointf:
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, a: float) -> None:
        ...
    @property
    def a(self) -> float:
        """
        < a in [0,1], a=0 => point is in v0, a=1 => point is in v1
        """
    @a.setter
    def a(self, arg0: float) -> None:
        ...
class SharpOffsetParameters(OffsetParameters):
    def __init__(self) -> None:
        ...
    @property
    def maxNewRank2VertDev(self) -> float:
        """
        maximal surface deviation to introduce new rank 2 vertex (on intersection of 2 planes), measured in voxelSize
        """
    @maxNewRank2VertDev.setter
    def maxNewRank2VertDev(self, arg0: float) -> None:
        ...
    @property
    def maxNewRank3VertDev(self) -> float:
        """
        maximal surface deviation to introduce new rank 3 vertex (on intersection of 3 planes), measured in voxelSize
        """
    @maxNewRank3VertDev.setter
    def maxNewRank3VertDev(self, arg0: float) -> None:
        ...
    @property
    def maxOldVertPosCorrection(self) -> float:
        """
        correct positions of the input vertices using reference mesh by not more than this distance, measured in voxelSize;
        big correction can be wrong and result from self-intersections in the reference mesh
        """
    @maxOldVertPosCorrection.setter
    def maxOldVertPosCorrection(self, arg0: float) -> None:
        ...
    @property
    def minNewVertDev(self) -> float:
        """
        minimal surface deviation to introduce new vertex in a voxel, measured in voxelSize
        """
    @minNewVertDev.setter
    def minNewVertDev(self, arg0: float) -> None:
        ...
    @property
    def outSharpEdges(self) -> UndirectedEdgeBitSet:
        """
        if non-null then created sharp edges will be saved here
        """
    @outSharpEdges.setter
    def outSharpEdges(self, arg0: UndirectedEdgeBitSet) -> None:
        ...
class SignDetectionMode:
    """
    How to determine the sign of distances from a mesh
    
    Members:
    
      Unsigned : unsigned distance, useful for bidirectional `Shell` offset
    
      OpenVDB : sign detection from OpenVDB library, which is good and fast if input geometry is closed
    
      ProjectionNormal : the sign is determined based on pseudonormal in closest mesh point (unsafe in case of self-intersections
    
      WindingRule : ray intersection counter, significantly slower than ProjectionNormal and does not support holes in mesh
    
      HoleWindingRule : computes winding number generalization with support of holes in mesh, slower than WindingRule
    """
    HoleWindingRule: typing.ClassVar[SignDetectionMode]  # value = <SignDetectionMode.HoleWindingRule: 4>
    OpenVDB: typing.ClassVar[SignDetectionMode]  # value = <SignDetectionMode.OpenVDB: 1>
    ProjectionNormal: typing.ClassVar[SignDetectionMode]  # value = <SignDetectionMode.ProjectionNormal: 2>
    Unsigned: typing.ClassVar[SignDetectionMode]  # value = <SignDetectionMode.Unsigned: 0>
    WindingRule: typing.ClassVar[SignDetectionMode]  # value = <SignDetectionMode.WindingRule: 3>
    __members__: typing.ClassVar[dict[str, SignDetectionMode]]  # value = {'Unsigned': <SignDetectionMode.Unsigned: 0>, 'OpenVDB': <SignDetectionMode.OpenVDB: 1>, 'ProjectionNormal': <SignDetectionMode.ProjectionNormal: 2>, 'WindingRule': <SignDetectionMode.WindingRule: 3>, 'HoleWindingRule': <SignDetectionMode.HoleWindingRule: 4>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class SignedDistanceToMeshResult:
    def __init__(self) -> None:
        ...
    @property
    def dist(self) -> float:
        """
        distance from pt to proj (positive - outside, negative - inside the mesh)
        """
    @dist.setter
    def dist(self, arg0: float) -> None:
        ...
    @property
    def mtp(self) -> MeshTriPoint:
        """
        its barycentric representation
        """
    @mtp.setter
    def mtp(self, arg0: MeshTriPoint) -> None:
        ...
    @property
    def proj(self) -> PointOnFace:
        """
        the closest point on mesh
        """
    @proj.setter
    def proj(self, arg0: PointOnFace) -> None:
        ...
class SimpleVolume:
    """
    Voxels representation as "vector of float"
    """
    data: vectorFloat
    voxelSize: Vector3f
    def __init__(self) -> None:
        ...
    @property
    def dims(self) -> Vector3i:
        """
        Size of voxels space
        """
    @dims.setter
    def dims(self, arg0: Vector3i) -> None:
        ...
    @property
    def max(self) -> float:
        """
        Maximum value from all voxels
        """
    @max.setter
    def max(self, arg0: float) -> None:
        ...
    @property
    def min(self) -> float:
        """
        Minimum value from all voxels
        """
    @min.setter
    def min(self, arg0: float) -> None:
        ...
class SlicePlane:
    """
    Members:
    
      XY : XY plane
    
      YZ : YZ plane
    
      ZX : XZ plane
    
      None : None
    """
    None: typing.ClassVar[SlicePlane]  # value = <SlicePlane.None: 3>
    XY: typing.ClassVar[SlicePlane]  # value = <SlicePlane.XY: 2>
    YZ: typing.ClassVar[SlicePlane]  # value = <SlicePlane.YZ: 0>
    ZX: typing.ClassVar[SlicePlane]  # value = <SlicePlane.ZX: 1>
    __members__: typing.ClassVar[dict[str, SlicePlane]]  # value = {'XY': <SlicePlane.XY: 2>, 'YZ': <SlicePlane.YZ: 0>, 'ZX': <SlicePlane.ZX: 1>, 'None': <SlicePlane.None: 3>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class SphereParams:
    numMeshVertices: int
    radius: float
    def __init__(self) -> None:
        ...
class StitchHolesParams:
    """
    Structure has some options to control buildCylinderBetweenTwoHoles
    """
    def __init__(self) -> None:
        ...
    @property
    def metric(self) -> FillHoleMetric:
        """
        Specifies triangulation metric
        default for buildCylinderBetweenTwoHoles: getComplexStitchMetric
        """
    @metric.setter
    def metric(self, arg0: FillHoleMetric) -> None:
        ...
    @property
    def outNewFaces(self) -> FaceBitSet:
        """
        If not nullptr accumulate new faces
        """
    @outNewFaces.setter
    def outNewFaces(self, arg0: FaceBitSet) -> None:
        ...
class SubdivideSettings:
    def __init__(self) -> None:
        ...
    @property
    def criticalAspectRatioFlip(self) -> float:
        """
        If this value is less than FLT_MAX then edge flips will ignore dihedral angle check if one of triangles has aspect ratio more than this value
        """
    @criticalAspectRatioFlip.setter
    def criticalAspectRatioFlip(self, arg0: float) -> None:
        ...
    @property
    def maxAngleChangeAfterFlip(self) -> float:
        """
        Improves local mesh triangulation by doing edge flips if it does change dihedral angle more than on this value
        """
    @maxAngleChangeAfterFlip.setter
    def maxAngleChangeAfterFlip(self, arg0: float) -> None:
        ...
    @property
    def maxDeviationAfterFlip(self) -> float:
        """
        Improves local mesh triangulation by doing edge flips if it does not make too big surface deviation
        """
    @maxDeviationAfterFlip.setter
    def maxDeviationAfterFlip(self, arg0: float) -> None:
        ...
    @property
    def maxEdgeLen(self) -> float:
        """
        Maximal possible edge length created during decimation
        """
    @maxEdgeLen.setter
    def maxEdgeLen(self, arg0: float) -> None:
        ...
    @property
    def maxEdgeSplits(self) -> int:
        """
        Maximum number of edge splits allowed
        """
    @maxEdgeSplits.setter
    def maxEdgeSplits(self, arg0: int) -> None:
        ...
    @property
    def maxTriAspectRatio(self) -> float:
        """
        An edge is subdivided only if both its left and right triangles have aspect ratio below or equal to this value. Please set it to a smaller value only if subdivideBorder==false, otherwise many narrow triangles can appear near border
        """
    @maxTriAspectRatio.setter
    def maxTriAspectRatio(self, arg0: float) -> None:
        ...
    @property
    def minSharpDihedralAngle(self) -> float:
        """
        In case of activated smoothMode, the smoothness is locally deactivated at the edges having dihedral angle at least this value
        """
    @minSharpDihedralAngle.setter
    def minSharpDihedralAngle(self, arg0: float) -> None:
        ...
    @property
    def minTriAspectRatio(self) -> float:
        """
        An edge is subdivided only if its left or right triangle has aspect ratio above or equal to this value. Please set it to a larger value if you would like to subdivide edges near degenerate triangles only
        """
    @minTriAspectRatio.setter
    def minTriAspectRatio(self, arg0: float) -> None:
        ...
    @property
    def newVerts(self) -> VertBitSet:
        """
        New vertices appeared during subdivision will be added here
        """
    @newVerts.setter
    def newVerts(self, arg0: VertBitSet) -> None:
        ...
    @property
    def region(self) -> FaceBitSet:
        """
        Region on mesh to be subdivided, it is updated during the operation
        """
    @region.setter
    def region(self, arg0: FaceBitSet) -> None:
        ...
    @property
    def smoothMode(self) -> bool:
        """
        Puts new vertices so that they form a smooth surface together with existing vertices.
        This option works best for natural surfaces without sharp edges in between triangles
        """
    @smoothMode.setter
    def smoothMode(self, arg0: bool) -> None:
        ...
    @property
    def subdivideBorder(self) -> bool:
        """
        If false do not touch border edges (cannot subdivide lone faces)
        use findRegionOuterFaces to find boundary faces
        """
    @subdivideBorder.setter
    def subdivideBorder(self, arg0: bool) -> None:
        ...
class SurfacePath:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: EdgePoint) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: SurfacePath) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> SurfacePath:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> EdgePoint:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: SurfacePath) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: SurfacePath) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: EdgePoint) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: SurfacePath) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: EdgePoint) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: EdgePoint) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: SurfacePath) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: EdgePoint) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> EdgePoint:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> EdgePoint:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: EdgePoint) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class SurfacePaths:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: SurfacePath) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: SurfacePaths) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> SurfacePaths:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> SurfacePath:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: SurfacePaths) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: SurfacePaths) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: SurfacePath) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: SurfacePaths) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: SurfacePath) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: SurfacePath) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: SurfacePaths) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: SurfacePath) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> SurfacePath:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> SurfacePath:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: SurfacePath) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class SymbolMeshParams:
    def __init__(self) -> None:
        ...
    @property
    def fontDetalization(self) -> int:
        """
        Detailization of Bezier curves on font glyphs
        """
    @fontDetalization.setter
    def fontDetalization(self, arg0: int) -> None:
        ...
    @property
    def pathToFontFile(self) -> Path:
        """
        Path to font file
        """
    @pathToFontFile.setter
    def pathToFontFile(self, arg0: Path) -> None:
        ...
    @property
    def symbolsDistanceAdditionalOffset(self) -> Vector2f:
        """
        Additional offset between symbols
        X: In symbol size: 1.0f adds one "space", 0.5 adds half "space". Should be >= 0.0f
        Y: In symbol size: 1.0f adds one base height, 0.5 adds half base height
        """
    @symbolsDistanceAdditionalOffset.setter
    def symbolsDistanceAdditionalOffset(self, arg0: Vector2f) -> None:
        ...
    @property
    def text(self) -> str:
        """
        Text that will be made mesh
        """
    @text.setter
    def text(self, arg0: str) -> None:
        ...
class TextAlignParams(SymbolMeshParams):
    def __init__(self) -> None:
        ...
    @property
    def direction(self) -> Vector3f:
        """
        Direction of text
        """
    @direction.setter
    def direction(self, arg0: Vector3f) -> None:
        ...
    @property
    def fontHeight(self) -> float:
        """
        Font height, meters
        """
    @fontHeight.setter
    def fontHeight(self, arg0: float) -> None:
        ...
    @property
    def pivotPoint(self) -> Vector2f:
        """
        Position of the startPoint in a text bounding box
        """
    @pivotPoint.setter
    def pivotPoint(self, arg0: Vector2f) -> None:
        ...
    @property
    def startPoint(self) -> MeshTriPoint:
        """
        Start coordinate on mesh, represent lowest left corner of text
        """
    @startPoint.setter
    def startPoint(self, arg0: MeshTriPoint) -> None:
        ...
    @property
    def surfaceOffset(self) -> float:
        """
        Text mesh inside and outside offset of input mesh
        """
    @surfaceOffset.setter
    def surfaceOffset(self, arg0: float) -> None:
        ...
    @property
    def textMaximumMovement(self) -> float:
        """
        Maximum possible movement of text mesh alignment, meters
        """
    @textMaximumMovement.setter
    def textMaximumMovement(self, arg0: float) -> None:
        ...
class ThreeVertIds:
    def __init__(self, arg0: VertId, arg1: VertId, arg2: VertId) -> None:
        ...
class TriPointf:
    """
    encodes a point inside a triangle using barycentric coordinates
    	Notations used below: v0, v1, v2 - points of the triangle
    """
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, a: float, b: float) -> None:
        ...
    @typing.overload
    def __init__(self, p: Vector3f, v0: Vector3f, v1: Vector3f, v2: Vector3f) -> None:
        """
        given a point coordinates and triangle (v0,v1,v2) computes barycentric coordinates of the point
        """
    @typing.overload
    def __init__(self, p: Vector3f, v1: Vector3f, v2: Vector3f) -> None:
        """
        given a point coordinates and triangle (0,v1,v2) computes barycentric coordinates of the point
        """
    @property
    def a(self) -> float:
        """
        barycentric coordinates:
        	a+b in [0,1], a+b=0 => point is in v0, a+b=1 => point is on [v1,v2] edge
        a in [0,1], a=0 => point is on [v2,v0] edge, a=1 => point is in v1
        """
    @a.setter
    def a(self, arg0: float) -> None:
        ...
    @property
    def b(self) -> float:
        """
        b in [0,1], b=0 => point is on [v0,v1] edge, b=1 => point is in v2
        """
    @b.setter
    def b(self, arg0: float) -> None:
        ...
class Triangulation:
    vec: vectorThreeVertIds
    def __init__(self) -> None:
        ...
class TriangulationParameters:
    """
    Parameters of point cloud triangulation
    """
    def __init__(self) -> None:
        ...
    @property
    def avgNumNeighbours(self) -> int:
        """
        The triangulation calculates the radius at which the average
        number of neighboring points is closest to this parameter.
        This radius is used to determine the local triangulation zone.
        note: Too small value can make not optimal triangulation and additional holes
        Too big value increases difficulty of optimization and can make local optimum of local triangulation
        """
    @avgNumNeighbours.setter
    def avgNumNeighbours(self, arg0: int) -> None:
        ...
    @property
    def critAngle(self) -> float:
        """
        Critical angle of triangles in local triangulation (angle between triangles in fan should be less then this value)
        """
    @critAngle.setter
    def critAngle(self, arg0: float) -> None:
        ...
    @property
    def critHoleLength(self) -> float:
        """
        Critical length of hole (all holes with length less then this value will be filled)
        If value is subzero it is set automaticly to 0.7*bbox.diagonal()
        """
    @critHoleLength.setter
    def critHoleLength(self, arg0: float) -> None:
        ...
class UndirectedEdgeBitSet(BoostBitSet):
    def __and__(self, arg0: UndirectedEdgeBitSet) -> UndirectedEdgeBitSet:
        ...
    def __iand__(self, arg0: UndirectedEdgeBitSet) -> UndirectedEdgeBitSet:
        ...
    def __init__(self) -> None:
        ...
    def __ior__(self, arg0: UndirectedEdgeBitSet) -> UndirectedEdgeBitSet:
        ...
    def __isub__(self, arg0: UndirectedEdgeBitSet) -> UndirectedEdgeBitSet:
        ...
    def __ixor__(self, arg0: UndirectedEdgeBitSet) -> UndirectedEdgeBitSet:
        ...
    def __or__(self, arg0: UndirectedEdgeBitSet) -> UndirectedEdgeBitSet:
        ...
    def __sub__(self, arg0: UndirectedEdgeBitSet) -> UndirectedEdgeBitSet:
        ...
    def __xor__(self, arg0: UndirectedEdgeBitSet) -> UndirectedEdgeBitSet:
        ...
    def flip(self) -> UndirectedEdgeBitSet:
        ...
    def resize(self, arg0: int, arg1: bool) -> None:
        ...
    def set(self, arg0: UndirectedEdgeId, arg1: bool) -> UndirectedEdgeBitSet:
        ...
    def test(self, arg0: UndirectedEdgeId) -> bool:
        ...
class UndirectedEdgeId:
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: int) -> None:
        ...
    def get(self) -> int:
        ...
    def valid(self) -> bool:
        ...
class UndirectedEdgeMap:
    vec: vectorUndirectedEdges
    def __init__(self) -> None:
        ...
class UndirectedEdgeUndirectedEdge:
    aUndirEdge: UndirectedEdgeId
    bUndirEdge: UndirectedEdgeId
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, a: UndirectedEdgeId, b: UndirectedEdgeId) -> None:
        ...
class UniteManyMeshesParams:
    """
    Parameters structure for uniteManyMeshes function
    """
    def __init__(self) -> None:
        ...
    @property
    def fixDegenerations(self) -> bool:
        """
        Try fix degenerations after each boolean step, to prevent boolean failure due to high amount of degenerated faces
        useful on meshes with many coincident surfaces 
        (useRandomShifts used for same issue)
        """
    @fixDegenerations.setter
    def fixDegenerations(self, arg0: bool) -> None:
        ...
    @property
    def maxAllowedError(self) -> float:
        """
        Max allowed random shifts in each direction, and max allowed deviation after degeneration fixing
        not used if both flags (useRandomShifts,fixDegenerations) are false
        """
    @maxAllowedError.setter
    def maxAllowedError(self, arg0: float) -> None:
        ...
    @property
    def newFaces(self) -> FaceBitSet:
        """
        If set, the bitset will store new faces created by boolean operations
        """
    @newFaces.setter
    def newFaces(self, arg0: FaceBitSet) -> None:
        ...
    @property
    def randomShiftsSeed(self) -> int:
        """
        Seed that is used for random shifts
        """
    @randomShiftsSeed.setter
    def randomShiftsSeed(self, arg0: int) -> None:
        ...
    @property
    def useRandomShifts(self) -> bool:
        """
        Apply random shift to each mesh, to prevent degenerations on coincident surfaces
        """
    @useRandomShifts.setter
    def useRandomShifts(self, arg0: bool) -> None:
        ...
class VdbVolume:
    """
    Voxels representation as "VDB FloatGrid"
    """
    data: FloatGrid
    voxelSize: Vector3f
    def __init__(self) -> None:
        ...
    @property
    def dims(self) -> Vector3i:
        """
        Size of voxels space
        """
    @dims.setter
    def dims(self, arg0: Vector3i) -> None:
        ...
    @property
    def max(self) -> float:
        """
        Maximum value from all voxels
        """
    @max.setter
    def max(self, arg0: float) -> None:
        ...
    @property
    def min(self) -> float:
        """
        Minimum value from all voxels
        """
    @min.setter
    def min(self, arg0: float) -> None:
        ...
class Vector2d:
    """
    two-dimensional vector
    """
    __hash__: typing.ClassVar[None] = None
    x: float
    y: float
    @staticmethod
    def diagonal(a: float) -> Vector2d:
        ...
    @staticmethod
    def minusX() -> Vector2d:
        ...
    @staticmethod
    def minusY() -> Vector2d:
        ...
    @staticmethod
    def plusX() -> Vector2d:
        ...
    @staticmethod
    def plusY() -> Vector2d:
        ...
    def __add__(self, arg0: Vector2d) -> Vector2d:
        ...
    def __eq__(self, arg0: Vector2d) -> bool:
        ...
    def __iadd__(self, arg0: Vector2d) -> Vector2d:
        ...
    def __imul__(self, arg0: float) -> Vector2d:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, x: float, y: float) -> None:
        ...
    def __isub__(self, arg0: Vector2d) -> Vector2d:
        ...
    def __itruediv__(self, arg0: float) -> Vector2d:
        ...
    def __mul__(self, arg0: float) -> Vector2d:
        ...
    def __neg__(self) -> Vector2d:
        ...
    def __repr__(self) -> str:
        ...
    def __rmul__(self, arg0: float) -> Vector2d:
        ...
    def __sub__(self, arg0: Vector2d) -> Vector2d:
        ...
    def __truediv__(self, arg0: float) -> Vector2d:
        ...
    def length(self) -> float:
        ...
    def lengthSq(self) -> float:
        ...
    def normalized(self) -> Vector2d:
        ...
class Vector2f:
    """
    two-dimensional vector
    """
    __hash__: typing.ClassVar[None] = None
    x: float
    y: float
    @staticmethod
    def diagonal(a: float) -> Vector2f:
        ...
    @staticmethod
    def minusX() -> Vector2f:
        ...
    @staticmethod
    def minusY() -> Vector2f:
        ...
    @staticmethod
    def plusX() -> Vector2f:
        ...
    @staticmethod
    def plusY() -> Vector2f:
        ...
    def __add__(self, arg0: Vector2f) -> Vector2f:
        ...
    def __eq__(self, arg0: Vector2f) -> bool:
        ...
    def __iadd__(self, arg0: Vector2f) -> Vector2f:
        ...
    def __imul__(self, arg0: float) -> Vector2f:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, x: float, y: float) -> None:
        ...
    def __isub__(self, arg0: Vector2f) -> Vector2f:
        ...
    def __itruediv__(self, arg0: float) -> Vector2f:
        ...
    def __mul__(self, arg0: float) -> Vector2f:
        ...
    def __neg__(self) -> Vector2f:
        ...
    def __repr__(self) -> str:
        ...
    def __rmul__(self, arg0: float) -> Vector2f:
        ...
    def __sub__(self, arg0: Vector2f) -> Vector2f:
        ...
    def __truediv__(self, arg0: float) -> Vector2f:
        ...
    def length(self) -> float:
        ...
    def lengthSq(self) -> float:
        ...
    def normalized(self) -> Vector2f:
        ...
class Vector2i:
    """
    two-dimensional vector
    """
    __hash__: typing.ClassVar[None] = None
    x: int
    y: int
    @staticmethod
    def diagonal(a: int) -> Vector2i:
        ...
    @staticmethod
    def minusX() -> Vector2i:
        ...
    @staticmethod
    def minusY() -> Vector2i:
        ...
    @staticmethod
    def plusX() -> Vector2i:
        ...
    @staticmethod
    def plusY() -> Vector2i:
        ...
    def __add__(self, arg0: Vector2i) -> Vector2i:
        ...
    def __eq__(self, arg0: Vector2i) -> bool:
        ...
    def __iadd__(self, arg0: Vector2i) -> Vector2i:
        ...
    def __imul__(self, arg0: int) -> Vector2i:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, x: int, y: int) -> None:
        ...
    def __isub__(self, arg0: Vector2i) -> Vector2i:
        ...
    def __itruediv__(self, arg0: int) -> Vector2i:
        ...
    def __mul__(self, arg0: int) -> Vector2i:
        ...
    def __neg__(self) -> Vector2i:
        ...
    def __repr__(self) -> str:
        ...
    def __rmul__(self, arg0: int) -> Vector2i:
        ...
    def __sub__(self, arg0: Vector2i) -> Vector2i:
        ...
    def __truediv__(self, arg0: int) -> Vector2i:
        ...
    def length(self) -> int:
        ...
    def lengthSq(self) -> int:
        ...
    def normalized(self) -> Vector2i:
        ...
class Vector3d:
    """
    three-dimensional vector
    """
    __hash__: typing.ClassVar[None] = None
    x: float
    y: float
    z: float
    @staticmethod
    def diagonal(arg0: float) -> Vector3d:
        ...
    def __add__(self, arg0: Vector3d) -> Vector3d:
        ...
    def __eq__(self, arg0: Vector3d) -> bool:
        ...
    def __iadd__(self, arg0: Vector3d) -> Vector3d:
        ...
    def __imul__(self, arg0: float) -> Vector3d:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, x: float, y: float, z: float) -> None:
        ...
    def __isub__(self, arg0: Vector3d) -> Vector3d:
        ...
    def __itruediv__(self, arg0: float) -> Vector3d:
        ...
    def __mul__(self, arg0: float) -> Vector3d:
        ...
    def __neg__(self) -> Vector3d:
        ...
    def __repr__(self) -> str:
        ...
    def __rmul__(self, arg0: float) -> Vector3d:
        ...
    def __sub__(self, arg0: Vector3d) -> Vector3d:
        ...
    def __truediv__(self, arg0: float) -> Vector3d:
        ...
    def length(self) -> float:
        ...
    def lengthSq(self) -> float:
        ...
    def normalized(self) -> Vector3d:
        ...
class Vector3f:
    """
    three-dimensional vector
    """
    __hash__: typing.ClassVar[None] = None
    x: float
    y: float
    z: float
    @staticmethod
    def diagonal(arg0: float) -> Vector3f:
        ...
    def __add__(self, arg0: Vector3f) -> Vector3f:
        ...
    def __eq__(self, arg0: Vector3f) -> bool:
        ...
    def __iadd__(self, arg0: Vector3f) -> Vector3f:
        ...
    def __imul__(self, arg0: float) -> Vector3f:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, x: float, y: float, z: float) -> None:
        ...
    def __isub__(self, arg0: Vector3f) -> Vector3f:
        ...
    def __itruediv__(self, arg0: float) -> Vector3f:
        ...
    def __mul__(self, arg0: float) -> Vector3f:
        ...
    def __neg__(self) -> Vector3f:
        ...
    def __repr__(self) -> str:
        ...
    def __rmul__(self, arg0: float) -> Vector3f:
        ...
    def __sub__(self, arg0: Vector3f) -> Vector3f:
        ...
    def __truediv__(self, arg0: float) -> Vector3f:
        ...
    def length(self) -> float:
        ...
    def lengthSq(self) -> float:
        ...
    def normalized(self) -> Vector3f:
        ...
class Vector3i:
    """
    three-dimensional vector
    """
    __hash__: typing.ClassVar[None] = None
    x: int
    y: int
    z: int
    @staticmethod
    def diagonal(arg0: int) -> Vector3i:
        ...
    def __add__(self, arg0: Vector3i) -> Vector3i:
        ...
    def __eq__(self, arg0: Vector3i) -> bool:
        ...
    def __iadd__(self, arg0: Vector3i) -> Vector3i:
        ...
    def __imul__(self, arg0: int) -> Vector3i:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, x: int, y: int, z: int) -> None:
        ...
    def __isub__(self, arg0: Vector3i) -> Vector3i:
        ...
    def __itruediv__(self, arg0: int) -> Vector3i:
        ...
    def __mul__(self, arg0: int) -> Vector3i:
        ...
    def __neg__(self) -> Vector3i:
        ...
    def __repr__(self) -> str:
        ...
    def __rmul__(self, arg0: int) -> Vector3i:
        ...
    def __sub__(self, arg0: Vector3i) -> Vector3i:
        ...
    def __truediv__(self, arg0: int) -> Vector3i:
        ...
    def lengthSq(self) -> int:
        ...
class VectorFloatByVert:
    vec: vectorFloat
    def __init__(self) -> None:
        ...
class VertBitSet(BoostBitSet):
    def __and__(self, arg0: VertBitSet) -> VertBitSet:
        ...
    def __iand__(self, arg0: VertBitSet) -> VertBitSet:
        ...
    def __init__(self) -> None:
        ...
    def __ior__(self, arg0: VertBitSet) -> VertBitSet:
        ...
    def __isub__(self, arg0: VertBitSet) -> VertBitSet:
        ...
    def __ixor__(self, arg0: VertBitSet) -> VertBitSet:
        ...
    def __or__(self, arg0: VertBitSet) -> VertBitSet:
        ...
    def __sub__(self, arg0: VertBitSet) -> VertBitSet:
        ...
    def __xor__(self, arg0: VertBitSet) -> VertBitSet:
        ...
    def flip(self) -> VertBitSet:
        ...
    def resize(self, arg0: int, arg1: bool) -> None:
        ...
    def set(self, arg0: VertId, arg1: bool) -> VertBitSet:
        ...
    def test(self, arg0: VertId) -> bool:
        ...
class VertColorMap:
    vec: vectorColor
    def __init__(self) -> None:
        ...
class VertCoords:
    vec: Contour3f
    def __init__(self) -> None:
        ...
class VertCoords2:
    vec: Contour2f
    def __init__(self) -> None:
        ...
class VertHashMap:
    def __bool__(self) -> bool:
        """
        Check whether the map is nonempty
        """
    @typing.overload
    def __contains__(self, arg0: VertId) -> bool:
        ...
    @typing.overload
    def __contains__(self, arg0: typing.Any) -> bool:
        ...
    def __delitem__(self, arg0: VertId) -> None:
        ...
    def __getitem__(self, arg0: VertId) -> VertId:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __repr__(self) -> str:
        """
        Return the canonical string representation of this map.
        """
    def __setitem__(self, arg0: VertId, arg1: VertId) -> None:
        ...
    def items(self) -> typing.ItemsView[VertHashMap]:
        ...
    def keys(self) -> typing.KeysView[VertHashMap]:
        ...
    def size(self) -> int:
        ...
    def values(self) -> typing.ValuesView[VertHashMap]:
        ...
class VertId:
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: int) -> None:
        ...
    def get(self) -> int:
        ...
    def valid(self) -> bool:
        ...
class VertMap:
    vec: vectorVerts
    def __init__(self) -> None:
        ...
class VertPair:
    def __init__(self) -> None:
        ...
    @property
    def norm(self) -> Vector3f:
        """
        surface normal in a vertex on the floating mesh (after applying Xf)
        """
    @norm.setter
    def norm(self, arg0: Vector3f) -> None:
        ...
    @property
    def normRef(self) -> Vector3f:
        """
        surface normal in a vertex on the reference mesh (after applying Xf)
        """
    @normRef.setter
    def normRef(self, arg0: Vector3f) -> None:
        ...
    @property
    def normalsAngleCos(self) -> float:
        """
        This is cosine between normals in first(floating mesh) and second(reference mesh) points
        It evaluates how good is this pair
        """
    @normalsAngleCos.setter
    def normalsAngleCos(self, arg0: float) -> None:
        ...
    @property
    def refPoint(self) -> Vector3f:
        """
        coordinates of the closest point on reference mesh (after applying refXf)
        """
    @refPoint.setter
    def refPoint(self, arg0: Vector3f) -> None:
        ...
    @property
    def vertDist2(self) -> float:
        """
        Storing squared distance between vertices
        """
    @vertDist2.setter
    def vertDist2(self, arg0: float) -> None:
        ...
    @property
    def vertId(self) -> VertId:
        """
        ID of the floating mesh vertex (usually applying Xf required)
        """
    @vertId.setter
    def vertId(self, arg0: VertId) -> None:
        ...
    @property
    def weight(self) -> float:
        """
        weight of the pair with respect to the sum of adjoining triangles square
        """
    @weight.setter
    def weight(self, arg0: float) -> None:
        ...
class ViewportId:
    """
    stores unique identifier of a viewport, which is power of two;
    id=0 has a special meaning of default viewport in some contexts
    """
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: int) -> None:
        ...
    def valid(self) -> bool:
        ...
    def value(self) -> int:
        ...
class ViewportMask:
    """
    stores mask of viewport unique identifiers
    """
    @staticmethod
    def all() -> ViewportMask:
        """
        mask meaning all or any viewports
        """
    @staticmethod
    def any() -> ViewportMask:
        """
        mask meaning all or any viewports
        """
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: int) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: ViewportId) -> None:
        ...
class VoxelsSaveSavingSettings:
    """
    stores together all data for save voxel object as a group of images
    """
    def __init__(self) -> None:
        ...
    @property
    def format(self) -> str:
        """
        format for file names, you should specify a placeholder for number and extension, e.g. "slice_{ 0:0{1} }.tif"
        """
    @format.setter
    def format(self, arg0: str) -> None:
        ...
    @property
    def path(self) -> Path:
        """
        path to directory where you want to save images
        """
    @path.setter
    def path(self, arg0: Path) -> None:
        ...
    @property
    def slicePlane(self) -> SlicePlane:
        """
        Plane which the object is sliced by. XY, XZ, or YZ
        """
    @slicePlane.setter
    def slicePlane(self, arg0: SlicePlane) -> None:
        ...
class WholeEdgeHashMap:
    def __bool__(self) -> bool:
        """
        Check whether the map is nonempty
        """
    @typing.overload
    def __contains__(self, arg0: UndirectedEdgeId) -> bool:
        ...
    @typing.overload
    def __contains__(self, arg0: typing.Any) -> bool:
        ...
    def __delitem__(self, arg0: UndirectedEdgeId) -> None:
        ...
    def __getitem__(self, arg0: UndirectedEdgeId) -> EdgeId:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __repr__(self) -> str:
        """
        Return the canonical string representation of this map.
        """
    def __setitem__(self, arg0: UndirectedEdgeId, arg1: EdgeId) -> None:
        ...
    def items(self) -> typing.ItemsView[WholeEdgeHashMap]:
        ...
    def keys(self) -> typing.KeysView[WholeEdgeHashMap]:
        ...
    def size(self) -> int:
        ...
    def values(self) -> typing.ValuesView[WholeEdgeHashMap]:
        ...
class WholeEdgeMap:
    vec: vectorEdges
    def __init__(self) -> None:
        ...
class WindingMode:
    """
    specify mode of detecting inside and outside parts of triangulation
    
    Members:
    
      NonZero
    
      Negative
    
      Positive
    """
    Negative: typing.ClassVar[WindingMode]  # value = <WindingMode.Negative: 2>
    NonZero: typing.ClassVar[WindingMode]  # value = <WindingMode.NonZero: 0>
    Positive: typing.ClassVar[WindingMode]  # value = <WindingMode.Positive: 1>
    __members__: typing.ClassVar[dict[str, WindingMode]]  # value = {'NonZero': <WindingMode.NonZero: 0>, 'Negative': <WindingMode.Negative: 2>, 'Positive': <WindingMode.Positive: 1>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class vectorColor:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: Color) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: vectorColor) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> vectorColor:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> Color:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: vectorColor) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: vectorColor) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: Color) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: vectorColor) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: Color) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: Color) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: vectorColor) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: Color) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> Color:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> Color:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: Color) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class vectorConstMeshPtr:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: Mesh) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: vectorConstMeshPtr) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> vectorConstMeshPtr:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> Mesh:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: vectorConstMeshPtr) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: vectorConstMeshPtr) -> bool:
        ...
    def __repr__(self) -> str:
        """
        Return the canonical string representation of this list.
        """
    @typing.overload
    def __setitem__(self, arg0: int, arg1: Mesh) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: vectorConstMeshPtr) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: Mesh) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: Mesh) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: vectorConstMeshPtr) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: Mesh) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> Mesh:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> Mesh:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: Mesh) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class vectorEdgePath:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: vectorEdges) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: vectorEdgePath) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> vectorEdgePath:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> vectorEdges:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: vectorEdgePath) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: vectorEdgePath) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: vectorEdges) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: vectorEdgePath) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: vectorEdges) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: vectorEdges) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: vectorEdgePath) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: vectorEdges) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> vectorEdges:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> vectorEdges:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: vectorEdges) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class vectorEdges:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: EdgeId) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: vectorEdges) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> vectorEdges:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> EdgeId:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: vectorEdges) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: vectorEdges) -> bool:
        ...
    def __repr__(self) -> str:
        """
        Return the canonical string representation of this list.
        """
    @typing.overload
    def __setitem__(self, arg0: int, arg1: EdgeId) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: vectorEdges) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: EdgeId) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: EdgeId) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: vectorEdges) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: EdgeId) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> EdgeId:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> EdgeId:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: EdgeId) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class vectorFaceBitSet:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: FaceBitSet) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: vectorFaceBitSet) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> vectorFaceBitSet:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> FaceBitSet:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: vectorFaceBitSet) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: vectorFaceBitSet) -> bool:
        ...
    def __repr__(self) -> str:
        """
        Return the canonical string representation of this list.
        """
    @typing.overload
    def __setitem__(self, arg0: int, arg1: FaceBitSet) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: vectorFaceBitSet) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: FaceBitSet) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: FaceBitSet) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: vectorFaceBitSet) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: FaceBitSet) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> FaceBitSet:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> FaceBitSet:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: FaceBitSet) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class vectorFaceFace:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: FaceFace) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: vectorFaceFace) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> vectorFaceFace:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> FaceFace:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: vectorFaceFace) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: vectorFaceFace) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: FaceFace) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: vectorFaceFace) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: FaceFace) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: FaceFace) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: vectorFaceFace) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: FaceFace) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> FaceFace:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> FaceFace:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: FaceFace) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class vectorFaces:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: FaceId) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: vectorFaces) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> vectorFaces:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> FaceId:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: vectorFaces) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: vectorFaces) -> bool:
        ...
    def __repr__(self) -> str:
        """
        Return the canonical string representation of this list.
        """
    @typing.overload
    def __setitem__(self, arg0: int, arg1: FaceId) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: vectorFaces) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: FaceId) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: FaceId) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: vectorFaces) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: FaceId) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> FaceId:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> FaceId:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: FaceId) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class vectorFloat:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: float) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: vectorFloat) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> vectorFloat:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> float:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: vectorFloat) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: vectorFloat) -> bool:
        ...
    def __repr__(self) -> str:
        """
        Return the canonical string representation of this list.
        """
    @typing.overload
    def __setitem__(self, arg0: int, arg1: float) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: vectorFloat) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: float) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: float) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: vectorFloat) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: float) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> float:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> float:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: float) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class vectorICPVertPair:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: VertPair) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: vectorICPVertPair) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> vectorICPVertPair:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> VertPair:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: vectorICPVertPair) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: vectorICPVertPair) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: VertPair) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: vectorICPVertPair) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: VertPair) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: VertPair) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: vectorICPVertPair) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: VertPair) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> VertPair:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> VertPair:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: VertPair) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class vectorMesh:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: Mesh) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: vectorMesh) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> vectorMesh:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> Mesh:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: vectorMesh) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: vectorMesh) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: Mesh) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: vectorMesh) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: Mesh) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: Mesh) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: vectorMesh) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: Mesh) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> Mesh:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> Mesh:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: Mesh) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class vectorThreeVertIds:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: ThreeVertIds) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: vectorThreeVertIds) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> vectorThreeVertIds:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> ThreeVertIds:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: vectorThreeVertIds) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: vectorThreeVertIds) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: ThreeVertIds) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: vectorThreeVertIds) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: ThreeVertIds) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: ThreeVertIds) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: vectorThreeVertIds) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: ThreeVertIds) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> ThreeVertIds:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> ThreeVertIds:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: ThreeVertIds) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class vectorUndirectedEdgeUndirectedEdge:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: UndirectedEdgeUndirectedEdge) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: vectorUndirectedEdgeUndirectedEdge) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> vectorUndirectedEdgeUndirectedEdge:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> UndirectedEdgeUndirectedEdge:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: vectorUndirectedEdgeUndirectedEdge) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: vectorUndirectedEdgeUndirectedEdge) -> bool:
        ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: UndirectedEdgeUndirectedEdge) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: vectorUndirectedEdgeUndirectedEdge) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: UndirectedEdgeUndirectedEdge) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: UndirectedEdgeUndirectedEdge) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: vectorUndirectedEdgeUndirectedEdge) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: UndirectedEdgeUndirectedEdge) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> UndirectedEdgeUndirectedEdge:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> UndirectedEdgeUndirectedEdge:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: UndirectedEdgeUndirectedEdge) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class vectorUndirectedEdges:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: UndirectedEdgeId) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: vectorUndirectedEdges) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> vectorUndirectedEdges:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> UndirectedEdgeId:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: vectorUndirectedEdges) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: vectorUndirectedEdges) -> bool:
        ...
    def __repr__(self) -> str:
        """
        Return the canonical string representation of this list.
        """
    @typing.overload
    def __setitem__(self, arg0: int, arg1: UndirectedEdgeId) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: vectorUndirectedEdges) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: UndirectedEdgeId) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: UndirectedEdgeId) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: vectorUndirectedEdges) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: UndirectedEdgeId) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> UndirectedEdgeId:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> UndirectedEdgeId:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: UndirectedEdgeId) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class vectorVertBitSet:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: VertBitSet) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: vectorVertBitSet) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> vectorVertBitSet:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> VertBitSet:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: vectorVertBitSet) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: vectorVertBitSet) -> bool:
        ...
    def __repr__(self) -> str:
        """
        Return the canonical string representation of this list.
        """
    @typing.overload
    def __setitem__(self, arg0: int, arg1: VertBitSet) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: vectorVertBitSet) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: VertBitSet) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: VertBitSet) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: vectorVertBitSet) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: VertBitSet) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> VertBitSet:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> VertBitSet:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: VertBitSet) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
class vectorVerts:
    __hash__: typing.ClassVar[None] = None
    def __bool__(self) -> bool:
        """
        Check whether the list is nonempty
        """
    def __contains__(self, x: VertId) -> bool:
        """
        Return true the container contains ``x``
        """
    @typing.overload
    def __delitem__(self, arg0: int) -> None:
        """
        Delete the list elements at index ``i``
        """
    @typing.overload
    def __delitem__(self, arg0: slice) -> None:
        """
        Delete list elements using a slice object
        """
    def __eq__(self, arg0: vectorVerts) -> bool:
        ...
    @typing.overload
    def __getitem__(self, s: slice) -> vectorVerts:
        """
        Retrieve list elements using a slice object
        """
    @typing.overload
    def __getitem__(self, arg0: int) -> VertId:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, arg0: vectorVerts) -> None:
        """
        Copy constructor
        """
    @typing.overload
    def __init__(self, arg0: typing.Iterable) -> None:
        ...
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, size: int) -> None:
        ...
    def __iter__(self) -> typing.Iterator:
        ...
    def __len__(self) -> int:
        ...
    def __ne__(self, arg0: vectorVerts) -> bool:
        ...
    def __repr__(self) -> str:
        """
        Return the canonical string representation of this list.
        """
    @typing.overload
    def __setitem__(self, arg0: int, arg1: VertId) -> None:
        ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: vectorVerts) -> None:
        """
        Assign list elements using a slice object
        """
    def append(self, x: VertId) -> None:
        """
        Add an item to the end of the list
        """
    @typing.overload
    def clear(self) -> None:
        """
        Clear the contents
        """
    @typing.overload
    def clear(self) -> None:
        ...
    def count(self, x: VertId) -> int:
        """
        Return the number of times ``x`` appears in the list
        """
    def empty(self) -> bool:
        ...
    @typing.overload
    def extend(self, L: vectorVerts) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    @typing.overload
    def extend(self, L: typing.Iterable) -> None:
        """
        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: VertId) -> None:
        """
        Insert an item at a given position.
        """
    @typing.overload
    def pop(self) -> VertId:
        """
        Remove and return the last item
        """
    @typing.overload
    def pop(self, i: int) -> VertId:
        """
        Remove and return the item at index ``i``
        """
    def remove(self, x: VertId) -> None:
        """
        Remove the first item from the list whose value is x. It is an error if there is no such item.
        """
    def resize(self, arg0: int) -> None:
        ...
    def size(self) -> int:
        ...
def addBaseToPlanarMesh(mesh: Mesh, zOffset: float = 1.0) -> None:
    """
    Given a planar mesh with boundary on input located in plane XY, packs and extends it along Z on zOffset to make a volumetric closed mesh.
    Note! zOffset should be > 0.
    """
def alignTextToMesh(mesh: Mesh, params: TextAlignParams) -> ...:
    """
    create text on mesh
    """
@typing.overload
def angle(a: Vector3f, b: Vector3f) -> float:
    """
    angle in radians between two vectors
    """
@typing.overload
def angle(a: Vector3d, b: Vector3d) -> float:
    """
    angle in radians between two vectors
    """
def boolean(meshA: Mesh, meshB: Mesh, operation: BooleanOperation, rigidB2A: AffineXf3f = None, mapper: BooleanResultMapper = None, cb: typing.Callable[[float], bool] = None) -> BooleanResult:
    """
    Makes new mesh - result of boolean operation on mesh `A` and mesh `B`
    	meshA - Input mesh `A`
    	meshB - Input mesh `B`
    	operation - CSG operation to perform
    	rigidB2A - Transform from mesh `B` space to mesh `A` space
    	mapper - Optional output structure to map mesh `A` and mesh `B` topology to result mesh topology
    
    note: Input meshes should have no self-intersections in intersecting zone
    note: If meshes are not closed in intersecting zone some boolean operations are not allowed (as far as input meshes interior and exterior cannot be determined)
    """
def buildBottom(mesh: Mesh, a: EdgeId, dir: Vector3f, holeExtension: float, outNewFaces: FaceBitSet = None) -> EdgeId:
    """
    adds cylindrical extension of given hole represented by one of its edges (having no valid left face)
    by adding new vertices located in lowest point of the hole -dir*holeExtension and 2 * number_of_hole_edge triangles;
    return: the edge of new hole opposite to input edge (a)
    """
@typing.overload
def buildCylinderBetweenTwoHoles(mesh: Mesh, a: EdgeId, b: EdgeId, params: StitchHolesParams = ...) -> None:
    """
    Build cylindrical patch to fill space between two holes represented by one of their edges each,
    default metric: ComplexStitchMetric
    	mesh - mesh with hole
    	a - EdgeId which represents 1st hole
    	b - EdgeId which represents 2nd hole
    	params - parameters of holes stitching
    """
@typing.overload
def buildCylinderBetweenTwoHoles(mesh: Mesh, params: StitchHolesParams = ...) -> bool:
    """
    this version finds holes in the mesh by itself and returns false if they are not found
    """
def buildShortestPath(mesh: Mesh, start: VertId, finish: VertId, maxPathLen: float = 3.4028234663852886e+38) -> vectorEdges:
    """
    builds shortest path in euclidean metric from start to finish vertices; if no path can be found then empty path is returned
    """
def buildShortestPathBiDir(mesh: Mesh, start: VertId, finish: VertId, maxPathLen: float = 3.4028234663852886e+38) -> vectorEdges:
    """
    builds shortest path in euclidean metric from start to finish vertices using faster search from both directions; if no path can be found then empty path is returned
    """
@typing.overload
def buildSmallestMetricPath(topology: MeshTopology, metric: typing.Callable[[EdgeId], float], start: VertId, finish: VertId, maxPathMetric: float = 3.4028234663852886e+38) -> vectorEdges:
    """
    builds shortest path in given metric from start to finish vertices; if no path can be found then empty path is returned
    """
@typing.overload
def buildSmallestMetricPath(topology: MeshTopology, metric: typing.Callable[[EdgeId], float], start: VertId, finish: VertBitSet, maxPathMetric: float = 3.4028234663852886e+38) -> vectorEdges:
    """
    builds shortest path in given metric from start to finish vertices; if no path can be found then empty path is returned
    """
def buildSmallestMetricPathBiDir(topology: MeshTopology, metric: typing.Callable[[EdgeId], float], start: VertId, finish: VertId, maxPathMetric: float = 3.4028234663852886e+38) -> vectorEdges:
    """
    builds shortest path in given metric from start to finish vertices using faster search from both directions; if no path can be found then empty path is returned
    """
@typing.overload
def calcOrientedArea(contour: Contour2f) -> float:
    """
    >0 for clockwise loop, < 0 for CCW loop
    """
@typing.overload
def calcOrientedArea(contour: Contour3f) -> Vector3f:
    """
    returns the vector with the magnitude equal to contour area, and directed to see the contour
    in ccw order from the vector tip
    """
def computeDistanceMapD(mp: MeshPart, params: MeshToDistanceMapParams, cb: typing.Callable[[float], bool] = None) -> DistanceMap:
    """
    computes distance map for presented projection parameters
    use MeshToDistanceMapParams constructor instead of overloads of this function
    MeshPart - input 3d model
    general call. You could customize params manually
    """
def computeGeodesicPath(mesh: Mesh, start: MeshTriPoint, end: MeshTriPoint, atype: GeodesicPathApprox, maxGeodesicIters: int = 100) -> SurfacePath:
    """
    Returns intermediate points of the geodesic path from start to end, where it crosses mesh edges
    """
def computePerFaceNormals(mesh: Mesh) -> FaceNormals:
    """
    returns a vector with face-normal in every element for valid mesh faces
    """
def computePerVertNormals(mesh: Mesh) -> VertCoords:
    """
    returns a vector with vertex normals in every element for valid mesh vertices
    """
@typing.overload
def computeSurfaceDistances(mesh: Mesh, start: MeshTriPoint, maxDist: float = 3.4028234663852886e+38, region: VertBitSet = None, maxVertUpdates: int = 3) -> VectorFloatByVert:
    """
    Computes path distances in mesh vertices from given start point, stopping when maxDist is reached;
    considered paths can go either along edges or straightly within triangles
    """
@typing.overload
def computeSurfaceDistances(mesh: Mesh, startVertices: VertBitSet, targetVertices: VertBitSet, maxDist: float = 3.4028234663852886e+38, region: VertBitSet = None, maxVertUpdates: int = 3) -> VectorFloatByVert:
    """
    Computes path distances in mesh vertices from given start vertices, stopping when all targetVertices or maxDist is reached;
    considered paths can go either along edges or straightly within triangles
    """
def copyMesh(mesh: Mesh) -> Mesh:
    """
    returns copy of input mesh
    """
def createSymbolsMesh(params: SymbolMeshParams) -> ...:
    """
    converts text string into Z-facing symbol mesh
    """
@typing.overload
def cross(a: Vector2i, b: Vector2i) -> int:
    """
    cross product
    """
@typing.overload
def cross(a: Vector2f, b: Vector2f) -> float:
    """
    cross product
    """
@typing.overload
def cross(a: Vector2d, b: Vector2d) -> float:
    """
    cross product
    """
@typing.overload
def cross(a: Vector3i, b: Vector3i) -> Vector3i:
    """
    cross product
    """
@typing.overload
def cross(a: Vector3f, b: Vector3f) -> Vector3f:
    """
    cross product
    """
@typing.overload
def cross(a: Vector3d, b: Vector3d) -> Vector3d:
    """
    cross product
    """
def cutMeshWithPlane(mesh: Mesh, plane: Plane3f, mapNew2Old: FaceMap = None) -> None:
    """
    This function cuts mesh with plane, leaving only part of mesh that lay in positive direction of normal
    	mesh - Input mesh that will be cut
    	plane - Input plane to cut mesh with
    	mapNew2Old - (this is optional output) map from newly generated faces to old faces (N-1)
    note: This function changes input mesh
    return: New edges that correspond to given contours
    """
def decimateMesh(mesh: Mesh, settings: DecimateSettings = ...) -> DecimateResult:
    """
    Collapse edges in mesh region according to the settings
    """
def detectBasisTunnels(mp: MeshPart) -> vectorEdgePath:
    """
    detects all not-contractible-in-point and not-equivalent tunnel loops on the mesh
    """
def detectTunnelFaces(mp: MeshPart, maxTunnelLength: float) -> FaceBitSet:
    """
    returns tunnels as a number of faces;
    if you remove these faces and patch every boundary with disk, then the surface will be topology equivalent to sphere
    """
@typing.overload
def dilateRegion(mesh: Mesh, region: FaceBitSet, dilation: float, callback: typing.Callable[[float], bool] = None) -> bool:
    """
    expands the region (of faces or vertices) on given value (in meters)
    """
@typing.overload
def dilateRegion(mesh: Mesh, region: VertBitSet, dilation: float, callback: typing.Callable[[float], bool] = None) -> bool:
    """
    expands the region (of faces or vertices) on given value (in meters)
    """
@typing.overload
def dilateRegionByMetric(topology: MeshTopology, metric: typing.Callable[[EdgeId], float], region: FaceBitSet, dilation: float, callback: typing.Callable[[float], bool] = None) -> bool:
    """
    expands the region (of faces or vertices) on given metric value
    """
@typing.overload
def dilateRegionByMetric(topology: MeshTopology, metric: typing.Callable[[EdgeId], float], region: VertBitSet, dilation: float, callback: typing.Callable[[float], bool] = None) -> bool:
    """
    expands the region (of faces or vertices) on given metric value
    """
@typing.overload
def distanceMapTo2DIsoPolyline(dm: DistanceMap, isoValue: float) -> Polyline2:
    """
    Converts distance map to 2d iso-lines:
    Iso-lines are created in space DistanceMap ( plane OXY with pixelSize = (1, 1) )
    """
@typing.overload
def distanceMapTo2DIsoPolyline(dm: DistanceMap, params: DistanceMapToWorld, isoValue: float, useDepth: bool) -> tuple[Polyline2, AffineXf3f]:
    """
    Iso-lines are created in real space.
    ( contours plane with parameters according DistanceMapToWorld )
    Return: pair contours in OXY & transformation from plane OXY to real contours plane
    """
def distanceMapToMesh(mp: DistanceMap, params: DistanceMapToWorld) -> Mesh:
    """
    converts distance map back to the mesh fragment with presented params
    """
@typing.overload
def dot(a: Vector2i, b: Vector2i) -> int:
    """
    dot product
    """
@typing.overload
def dot(a: Vector2f, b: Vector2f) -> float:
    """
    dot product
    """
@typing.overload
def dot(a: Vector2d, b: Vector2d) -> float:
    """
    dot product
    """
@typing.overload
def dot(a: Vector3i, b: Vector3i) -> int:
    """
    dot product
    """
@typing.overload
def dot(a: Vector3f, b: Vector3f) -> float:
    """
    dot product
    """
@typing.overload
def dot(a: Vector3d, b: Vector3d) -> float:
    """
    dot product
    """
def edgeCurvMetric(mesh: Mesh, angleSinFactor: float = 2.0, angleSinForBoundary: float = 0.0) -> typing.Callable[[EdgeId], float]:
    """
    returns edge's metric that depends both on edge's length and on the angle between its left and right faces
    	angleSinFactor - multiplier before dihedral angle sine in edge metric calculation (positive to prefer concave angles, negative - convex)
    	angleSinForBoundary - consider this dihedral angle sine for boundary edges
    """
def edgeLengthMetric(mesh: Mesh) -> typing.Callable[[EdgeId], float]:
    """
    returns edge's length as a metric
    """
def edgeTableMetric(topology: MeshTopology, metric: typing.Callable[[EdgeId], float]) -> typing.Callable[[EdgeId], float]:
    """
    pre-computes the metric for all mesh edges to quickly return it later for any edge
    """
@typing.overload
def erodeRegion(mesh: Mesh, region: FaceBitSet, dilation: float, callback: typing.Callable[[float], bool] = None) -> bool:
    """
    shrinks the region (of faces or vertices) on given value (in meters)
    """
@typing.overload
def erodeRegion(mesh: Mesh, region: VertBitSet, dilation: float, callback: typing.Callable[[float], bool] = None) -> bool:
    """
    shrinks the region (of faces or vertices) on given value (in meters)
    """
@typing.overload
def erodeRegionByMetric(topology: MeshTopology, metric: typing.Callable[[EdgeId], float], region: FaceBitSet, dilation: float, callback: typing.Callable[[float], bool] = None) -> bool:
    """
    shrinks the region (of faces or vertices) on given metric value
    """
@typing.overload
def erodeRegionByMetric(topology: MeshTopology, metric: typing.Callable[[EdgeId], float], region: VertBitSet, dilation: float, callback: typing.Callable[[float], bool] = None) -> bool:
    """
    shrinks the region (of faces or vertices) on given metric value
    """
@typing.overload
def expand(topology: MeshTopology, region: VertBitSet, hops: int = 1) -> None:
    """
    adds to the region all vertices within given number of hops (stars) from the initial region boundary
    """
@typing.overload
def expand(topology: MeshTopology, region: FaceBitSet, hops: int = 1) -> None:
    """
    adds to the region all faces within given number of hops (stars) from the initial region boundary
    """
def extractPlaneSections(mp: MeshPart, plane: Plane3f) -> SurfacePaths:
    """
    extracts all plane sections of given mesh
    """
@typing.overload
def fillContourLeft(topology: MeshTopology, contour: vectorEdges) -> FaceBitSet:
    """
    fill region located to the left from given edges
    """
@typing.overload
def fillContourLeft(topology: MeshTopology, contours: vectorEdgePath) -> FaceBitSet:
    """
    fill region located to the left from given edges
    """
@typing.overload
def fillContourLeftByGraphCut(topology: MeshTopology, contour: vectorEdges, metric: typing.Callable[[EdgeId], float]) -> FaceBitSet:
    """
    Fills region located to the left from given contour, by minimizing the sum of metric over the boundary
    """
@typing.overload
def fillContourLeftByGraphCut(topology: MeshTopology, contours: vectorEdgePath, metric: typing.Callable[[EdgeId], float]) -> FaceBitSet:
    """
    Fills region located to the left from given contours, by minimizing the sum of metric over the boundary
    """
def fillHole(mesh: Mesh, a: EdgeId, params: FillHoleParams = ...) -> None:
    """
    Fills given hole represented by one of its edges (having no valid left face),
    uses fillHoleTrivially if cannot fill hole without multiple edges,
    default metric: CircumscribedFillMetric
    	mesh - mesh with hole
    	a - EdgeId which represents hole
    	params - parameters of hole filling
    """
def findCollidingTriangles(a: MeshPart, b: MeshPart, rigidB2A: AffineXf3f = None, firstIntersectionOnly: bool = False) -> vectorFaceFace:
    """
    finds all pairs of colliding triangles from two meshes or two mesh regions
    	rigidB2A - rigid transformation from B-mesh space to A mesh space, nullptr considered as identity transformation
    	firstIntersectionOnly - if true then the function returns at most one pair of intersecting triangles and returns faster
    """
def findDegenerateFaces(mp: MeshPart, criticalAspectRatio: float = 3.4028234663852886e+38, cb: typing.Callable[[float], bool] = None) -> FaceBitSet:
    """
    finds faces which aspect ratio >= criticalAspectRatio
    """
def findHoleVertIdsByHoleEdges(tp: MeshTopology, holePaths: vectorEdgePath) -> HolesVertIds:
    """
    return vertices of holes that correspond internal contours representation of PlanarTriangulation
    """
def findLeftBoundary(topology: MeshTopology, region: FaceBitSet = None) -> vectorEdgePath:
    """
    returns all region boundary loops;
    every loop has region faces on the left, and not-region faces or holes on the right
    """
def findMaxDistanceSq(a: MeshPart, b: MeshPart, rigidB2A: AffineXf3f = None, upDistLimitSq: float = 3.4028234663852886e+38) -> float:
    """
    returns the maximum of the distances from each mesh point to another mesh in both directions
    	rigidB2A - rigid transformation from B-mesh space to A mesh space, nullptr considered as identity transformation
    	maxDistanceSq - upper limit on the positive distance in question, if the real distance is larger than the function exists returning maxDistanceSq
    """
def findMaxDistanceSqOneWay(a: MeshPart, b: MeshPart, rigidB2A: AffineXf3f = None, upDistLimitSq: float = 3.4028234663852886e+38) -> float:
    """
    returns the maximum of the distances from each B-mesh point to A-mesh
    	rigidB2A - rigid transformation from B-mesh space to A mesh space, nullptr considered as identity transformation
    	maxDistanceSq - upper limit on the positive distance in question, if the real distance is larger than the function exists returning maxDistanceSq
    """
def findOverhangs(mesh: Mesh, settings: FindOverhangsSettings) -> vectorFaceBitSet:
    """
    Find face regions that might create overhangs
    	mesh - source mesh
    	settings - parameters
    	return face regions
    """
def findProjection(pt: Vector3f, mp: MeshPart, upDistLimitSq: float = 3.4028234663852886e+38, xf: AffineXf3f = None, loDistLimitSq: float = 0.0, skipFace: FaceId = ...) -> MeshProjectionResult:
    """
    computes the closest point on mesh (or its region) to given point
    	upDistLimitSq upper limit on the distance in question, if the real distance is larger than the function exits returning upDistLimitSq and no valid point
    	xf mesh-to-point transformation, if not specified then identity transformation is assumed
    	loDistLimitSq low limit on the distance in question, if a point is found within this distance then it is immediately returned without searching for a closer one
    	skipFace this triangle will be skipped and never returned as a projection
    """
def findRightBoundary(topology: MeshTopology, region: FaceBitSet = None) -> vectorEdgePath:
    """
    returns all region boundary loops;
    every loop has region faces on the right, and not-region faces or holes on the left
    """
def findSelfCollidingEdges(polyline: Polyline2) -> vectorUndirectedEdgeUndirectedEdge:
    """
    finds all pairs of colliding edges from 2d polyline
    """
def findSelfCollidingTriangles(mp: MeshPart, cb: typing.Callable[[float], bool] = None) -> vectorFaceFace:
    """
    finds all pairs of colliding triangles from one mesh or a region
    """
def findSelfCollidingTrianglesBS(mp: MeshPart, cb: typing.Callable[[float], bool] = None) -> FaceBitSet:
    """
    finds union of all self-intersecting faces
    """
@typing.overload
def findSignedDistance(pt: Vector3f, mp: MeshPart, upDistLimitSq: float = 3.4028234663852886e+38, loDistLimitSq: float = 0.0) -> SignedDistanceToMeshResult | None:
    """
    computes the closest point on mesh (or its region) to given point and finds the distance with sign to it( positive - outside, negative - inside the mesh )
    	upDistLimitSq upper limit on the distance in question, if the real distance is larger then the function exits returning nullopt
    	loDistLimitSq low limit on the distance in question, if the real distance smaller then the function exits returning nullopt
    """
@typing.overload
def findSignedDistance(a: MeshPart, b: MeshPart, rigidB2A: AffineXf3f = None, upDistLimitSq: float = 3.4028234663852886e+38) -> MeshSignedDistanceResult:
    """
    computes minimal distance between two meshes
    	rigidB2A - rigid transformation from B-mesh space to A mesh space, nullptr considered as identity transformation
    	upDistLimitSq - upper limit on the positive distance in question, if the real distance is larger than the function exists returning upDistLimitSq and no valid points
    """
def fixMultipleEdges(mesh: Mesh) -> None:
    """
    finds and resolves multiple edges
    """
def fixSelfIntersections(mesh: Mesh, voxelSize: float) -> None:
    """
    fix self-intersections by converting to voxels and back
    """
@typing.overload
def fixUndercuts(mesh: Mesh, selectedArea: FaceBitSet, upDirection: Vector3f, voxelSize: float = 0.0, bottomExtension: float = 0.0) -> None:
    """
    aChanges mesh:
    Fills all holes first, then:
    fixes undercuts (in selected area) via prolonging widest points down
    Requires to update RenderObject after using
    upDirection is in mesh space
    voxelSize -  size of voxel in mesh rasterization, precision grows with lower voxelSize
    bottomExtension - this parameter specifies how long should bottom prolongation be, if (bottomExtension <= 0) bottomExtension = 2*voxelSize
    	if mesh is not closed this is used to prolong hole and make bottom
    
    if voxelSize == 0.0f it will be counted automaticly
    """
@typing.overload
def fixUndercuts(mesh: Mesh, upDirection: Vector3f, voxelSize: float = 0.0, bottomExtension: float = 0.0) -> None:
    """
    aChanges mesh:
    Fills all holes first, then:
    fixes undercuts via prolonging widest points down
    Requires to update RenderObject after using
    upDirection is in mesh space
    voxelSize -  size of voxel in mesh rasterization, precision grows with lower voxelSize
    bottomExtension - this parameter specifies how long should bottom prolongation be, if (bottomExtension <= 0) bottomExtension = 2*voxelSize
    	if mesh is not closed this is used to prolong hole and make bottom
    
    if voxelSize == 0.0f it will be counted automaticly
    """
def floatGridToVdbVolume(grid: FloatGrid) -> VdbVolume:
    """
    fills VdbVolume data from FloatGrid (does not fill voxels size, cause we expect it outside)
    """
def generalOffsetMesh(mp: MeshPart, offset: float, params: GeneralOffsetParameters = ...) -> Mesh:
    """
    Offsets mesh by converting it to voxels and back using one of three modes specified in the parameters
    """
def getAllComponents(meshPart: MeshPart, incidence: FaceIncidence = ...) -> vectorFaceBitSet:
    """
    gets all connected components of mesh part
    """
def getAllComponentsVerts(mesh: Mesh, region: VertBitSet = None) -> vectorVertBitSet:
    """
    gets all connected components of mesh part
    """
def getCircumscribedMetric(mesh: Mesh) -> FillHoleMetric:
    """
    This metric minimizes the sum of circumcircle radii for all triangles in the triangulation.
    It is rather fast to calculate, and it results in typically good triangulations.
    """
def getComplexFillMetric(mesh: Mesh, e: EdgeId) -> FillHoleMetric:
    """
    This metric minimizes the sum of triangleMetric for all triangles in the triangulation
    plus the sum edgeMetric for all edges inside and on the boundary of the triangulation.
    Where
    triangleMetric is proportional to weighted triangle area and triangle aspect ratio
    edgeMetric grows with angle between triangles as ( ( 1 - cos( x ) ) / ( 1 + cos( x ) ) ) ^ 4.
    """
def getComponent(meshPart: MeshPart, faceId: FaceId, incidence: FaceIncidence = ...) -> FaceBitSet:
    """
    returns one connected component containing given face,
    not effective to call more than once, if several components are needed use getAllComponents
    """
def getComponentVerts(mesh: Mesh, vertId: VertId, region: VertBitSet = None) -> VertBitSet:
    """
    returns one connected component containing given vertex,
    not effective to call more than once, if several components are needed use getAllComponentsVerts
    """
def getEdgeLengthFillMetric(mesh: Mesh) -> FillHoleMetric:
    """
    Simple metric minimizing the sum of all edge lengths
    """
def getEdgeLengthStitchMetric(mesh: Mesh) -> FillHoleMetric:
    """
    Forbids connecting vertices from the same hole
    Simple metric minimizing edge length
    """
def getFacesByMinEdgeLength(mesh: Mesh, minLength: float) -> FaceBitSet:
    """
    return faces with at least one edge longer than min edge length
    """
def getIncidentFaces(topology: MeshTopology, verts: VertBitSet) -> FaceBitSet:
    """
    composes the set of all faces incident to given vertices
    """
def getIncidentVerts(topology: MeshTopology, faces: FaceBitSet) -> VertBitSet:
    """
    composes the set of all vertices incident to given faces
    """
def getInnerFaces(topology: MeshTopology, verts: VertBitSet) -> FaceBitSet:
    """
    composes the set of all faces with all their vertices in given set
    """
def getInnerVerts(topology: MeshTopology, faces: FaceBitSet) -> VertBitSet:
    """
    composes the set of all vertices with all their faces in given set
    """
def getLargestComponent(meshPart: MeshPart, incidence: FaceIncidence = ...) -> FaceBitSet:
    """
    returns largest by surface area component
    """
def getLargestComponentVerts(mesh: Mesh, region: VertBitSet = None) -> VertBitSet:
    """
    returns largest by number of elements component
    """
def getMinAreaMetric(mesh: Mesh) -> FillHoleMetric:
    """
    This metric is for triangulation construction with minimal summed area of triangles.
    Warning: this metric can produce degenerated triangles
    """
def getPlaneFillMetric(mesh: Mesh, e: EdgeId) -> FillHoleMetric:
    """
    Same as getCircumscribedFillMetric, but with extra penalty for the triangles having
    normals looking in the opposite side of plane containing left of (e).
    """
def getSelectedMesh() -> Mesh:
    """
    copy selected mesh from scene tree
    """
def getUniversalMetric(mesh: Mesh) -> FillHoleMetric:
    """
    This metric minimizes the maximal dihedral angle between the faces in the triangulation
    and on its boundary, and it avoids creating too degenerate triangles;
     for planar holes it is the same as getCircumscribedMetric
    """
@typing.overload
def gridToMesh(grid: FloatGrid, voxelSize: Vector3f, isoValue: float = 0.0, adaptivity: float = 0.0, cb: typing.Callable[[float], bool] = None) -> Mesh:
    """
    Make mesh from FloatGrid.
    isoValue - layer of grid with this value would be converted in mesh.
    isoValue can be negative only in level set grids.
    adaptivity - [0.0;1.0] Ratio of combining small triangles into bigger ones.
    (Curvature can be lost on high values.)
    """
@typing.overload
def gridToMesh(vdbVolume: VdbVolume, isoValue: float = 0.0, adaptivity: float = 0.0, cb: typing.Callable[[float], bool] = None) -> Mesh:
    """
    Make mesh from VdbVolume.
    isoValue - layer of grid with this value would be converted in mesh.
    isoValue can be negative only in level set grids.
    adaptivity - [0.0;1.0] Ratio of combining small triangles into bigger ones.
    (Curvature can be lost on high values.)
    """
@typing.overload
def gridToMesh(grid: FloatGrid, voxelSize: Vector3f, maxFaces: int, isoValue: float = 0.0, adaptivity: float = 0.0, cb: typing.Callable[[float], bool] = None) -> Mesh:
    """
    Make mesh from FloatGrid.
    maxFaces - If mesh faces exceed this value error returns.
    isoValue - Layer of grid with this value would be converted in mesh.
    isoValue can be negative only in level set grids.
    adaptivity - [0.0;1.0] Ratio of combining small triangles into bigger ones.
    (Curvature can be lost on high values.)
    """
@typing.overload
def gridToMesh(vdbVolume: VdbVolume, maxFaces: int, isoValue: float = 0.0, adaptivity: float = 0.0, cb: typing.Callable[[float], bool] = None) -> Mesh:
    """
    Make mesh from VdbVolume.
    maxFaces - If mesh faces exceed this value error returns.
    isoValue - Layer of grid with this value would be converted in mesh.
    isoValue can be negative only in level set grids.
    adaptivity - [0.0;1.0] Ratio of combining small triangles into bigger ones.
    (Curvature can be lost on high values.)
    """
def hasMultipleEdges(topology: MeshTopology) -> bool:
    """
    finds multiple edges in the mesh
    """
def identityMetric() -> typing.Callable[[EdgeId], float]:
    """
    metric returning 1 for every edge
    """
def intersection(segm1: LineSegm2f, segm2: LineSegm2f) -> Vector2f | None:
    """
    finds an intersection between a segm1 and a segm2
    return null if they don't intersect (even if they match)
    """
def loadDCMFolder(path: Path, maxNumThreads: int = 4, callback: typing.Callable[[float], bool] = None) -> LoadDCMResult:
    """
    Loads first volumetric data from DICOM file(s)
    """
def loadDCMsFolder(path: Path, maxNumThreads: int = 4, callback: typing.Callable[[float], bool] = None) -> LoadDCMResults:
    """
    Loads all volumetric data from DICOM file(s)
    """
def loadDistanceMapFromImage(filename: Path, threshold: float = 0.003921568859368563) -> DistanceMap:
    """
    load distance map from monochrome image file
    	threshold - threshold of valid values [0.; 1.]. pixel with color less then threshold set invalid
    """
@typing.overload
def loadLines(path: Path, callback: typing.Callable[[float], bool] = None) -> Polyline3:
    """
    detects the format from file extension and loads polyline from it
    """
@typing.overload
def loadLines(fileHandle: typing.Any, extension: str) -> Polyline3:
    """
    load lines from python file handler, second arg: extension (`*.ext` format)
    """
@typing.overload
def loadMesh(path: Path, settings: MeshLoadSettings = ...) -> Mesh:
    """
    detects the format from file extension and loads mesh from it
    """
@typing.overload
def loadMesh(fileHandle: typing.Any, extension: str) -> Mesh:
    """
    load mesh from python file handler, second arg: extension (`*.ext` format)
    """
@typing.overload
def loadPoints(path: Path, colors: VertColorMap = None, outXf: AffineXf3f = None, callback: typing.Callable[[float], bool] = None) -> PointCloud:
    """
    detects the format from file extension and loads points from it
    """
@typing.overload
def loadPoints(fileHandle: typing.Any, extension: str) -> PointCloud:
    """
    load point cloud from python file handler, second arg: extension (`*.ext` format)
    """
def loadSceneObject(path: Path, callback: typing.Callable[[float], bool] = None) -> SceneObject:
    """
    Detects the format from file extension and loads scene object from it.
    """
def loadTiffDir(settings: LoadingTiffSettings) -> VdbVolume:
    """
    settings - Settings structure for loadTiffDir function
    """
def loadVoxels(path: Path, callback: typing.Callable[[float], bool] = None) -> VdbVolume:
    """
    Load raw voxels file, parsing parameters from name.
    """
@typing.overload
def makeConvexHull(points: VertCoords, validPoints: VertBitSet) -> Mesh:
    """
    Computes the Mesh of convex hull from given input points
    """
@typing.overload
def makeConvexHull(mesh: Mesh) -> Mesh:
    """
    Computes the Mesh of convex hull from given input `Mesh`
    """
@typing.overload
def makeConvexHull(pointCloud: PointCloud) -> Mesh:
    """
    Computes the Mesh of convex hull from given input `PointCloud`
    """
def makeCube(size: Vector3f = ..., base: Vector3f = ...) -> Mesh:
    """
    Base is "lower" corner of the cube coordinates
    """
def makeCylinder(radius: float = 0.10000000149011612, length: float = 1.0, resolution: int = 16) -> Mesh:
    """
    creates Z-looking cylinder with radius 'radius', height - 'length', its base have 'resolution' sides
    """
def makeCylinderAdvanced(radius0: float = 0.10000000149011612, radius1: float = 0.10000000149011612, start_angle: float = 0.0, arc_size: float = 6.2831854820251465, length: float = 1.0, resolution: int = 16) -> Mesh:
    ...
def makeDegenerateBandAroundRegion(mesh: Mesh, region: FaceBitSet) -> None:
    """
    creates a band of degenerate faces along the border of the specified region and the rest of the mesh
    the function is useful for extruding the region without changing the existing faces and creating holes
    	mesh - the target mesh
    	region - the region required to be separated by a band of degenerate faces
    """
def makeOuterHalfTorus(primaryRadius: float = 1.0, secondaryRadius: float = 0.10000000149011612, primaryResolution: int = 16, secondaryResolution: int = 16, points: Contour3f = None) -> Mesh:
    """
    creates torus without inner half faces
    main application - testing fillHole and Stitch
    """
def makeSphere(params: SphereParams) -> Mesh:
    """
    creates a mesh of sphere with irregular triangulation
    """
def makeTorus(primaryRadius: float = 1.0, secondaryRadius: float = 0.10000000149011612, primaryResolution: int = 16, secondaryResolution: int = 16, points: Contour3f = None) -> Mesh:
    """
    Z is symmetry axis of this torus
    points - optional out points of main circle
    """
def makeTorusWithComponents(primaryRadius: float = 1.0, secondaryRadius: float = 0.10000000149011612, primaryResolution: int = 16, secondaryResolution: int = 16, points: Contour3f = None) -> Mesh:
    """
    creates torus with empty sectors
    main application - testing Components
    """
def makeTorusWithSelfIntersections(primaryRadius: float = 1.0, secondaryRadius: float = 0.10000000149011612, primaryResolution: int = 16, secondaryResolution: int = 16, points: Contour3f = None) -> Mesh:
    """
    creates torus with empty sectors
    main application - testing Components
    """
def makeTorusWithSpikes(primaryRadius: float = 1.0, secondaryRadiusInner: float = 0.10000000149011612, secondaryRadiusOuter: float = 0.20000000298023224, primaryResolution: int = 16, secondaryResolution: int = 16, points: Contour3f = None) -> Mesh:
    """
    creates torus with some handed-up points
    main application - testing fixSpikes and Relax
    """
def makeTorusWithUndercut(primaryRadius: float = 1.0, secondaryRadiusInner: float = 0.10000000149011612, secondaryRadiusOuter: float = 0.20000000298023224, primaryResolution: int = 16, secondaryResolution: int = 16, points: Contour3f = None) -> Mesh:
    """
    creates torus with inner protruding half as undercut
    main application - testing fixUndercuts
    """
def makeUVSphere(radius: float = 1.0, horisontalResolution: int = 16, verticalResolution: int = 16) -> Mesh:
    """
    Z is polar axis of this UVSphere
    """
def mergeMehses(meshes: list) -> Mesh:
    """
    merge python list of meshes to one mesh
    """
def meshRegularMap(surfacePCPath: str, directionsPCPath: str, distancesPath: str, width: int, height: int) -> Mesh:
    """
    creates and select mesh by regular map
    	surfacePCPath - path to surface PointCloud
    	directionsPCPath - path to directions PointCloud
    	distancesPath - path to distances binnary file (1/distance per point)
    	width - map width
    	height - map height
    """
def meshToDistanceField(mp: MeshPart, xf: AffineXf3f, voxelSize: Vector3f, surfaceOffset: float = 3, cb: typing.Callable[[float], bool] = None) -> FloatGrid:
    """
    Does not require closed surface, resulting grid cannot be used for boolean operations.
    SurfaceOffset - the number voxels around surface to calculate distance in (should be positive).
    """
def meshToDistanceVolume(mesh: MeshPart, params: MeshToDistanceVolumeParams = ...) -> SimpleVolume:
    """
    makes SimpleVolume filled with (signed or unsigned) distances from Mesh with given settings
    """
def meshToLevelSet(mp: MeshPart, xf: AffineXf3f, voxelSize: Vector3f, surfaceOffset: float = 3, cb: typing.Callable[[float], bool] = None) -> FloatGrid:
    """
    Closed surface is required.
    SurfaceOffset - number voxels around surface to calculate distance in (should be positive).
    """
def meshToPointCloud(mesh: Mesh, saveNormals: bool = True, verts: VertBitSet = None) -> PointCloud:
    """
    Mesh to PointCloud
    """
def meshToVolume(mesh: Mesh, params: MeshToVolumeParams = ...) -> VdbVolume:
    """
    convert mesh to volume in (0,0,0)-(dim.x,dim.y,dim.z) grid box
    """
@typing.overload
def mixed(a: Vector3i, b: Vector3i, c: Vector3i) -> int:
    """
    mixed product
    """
@typing.overload
def mixed(a: Vector3f, b: Vector3f, c: Vector3f) -> float:
    """
    mixed product
    """
@typing.overload
def mixed(a: Vector3d, b: Vector3d, c: Vector3d) -> float:
    """
    mixed product
    """
@typing.overload
def mult(a: Vector3i, b: Vector3i) -> Vector3i:
    """
    per component multiplication
    """
@typing.overload
def mult(a: Vector3f, b: Vector3f) -> Vector3f:
    """
    per component multiplication
    """
@typing.overload
def mult(a: Vector3d, b: Vector3d) -> Vector3d:
    """
    per component multiplication
    """
def offsetMesh(mp: MeshPart, offset: float, params: OffsetParameters = ...) -> Mesh:
    """
    Offsets mesh by converting it to voxels and back
    use Shell type for non closed meshes
    so result mesh is always closed
    """
def planeSectionsToContours2f(mesh: Mesh, sections: SurfacePaths, meshToPlane: AffineXf3f) -> Contours2f:
    """
    converts PlaneSections in 2D contours by computing coordinate of each point, applying given xf to it, and retaining only x and y
    """
def pointGridSampling(cloud: PointCloud, voxelSize: float, cb: typing.Callable[[float], bool] = None) -> VertBitSet:
    """
    performs sampling of point cloud vertices;
    subdivides point cloud bounding box on voxels of approximately given size and returns at most one vertex per voxel
    """
def pointUniformSampling(pointCloud: PointCloud, distance: float, cb: typing.Callable[[float], bool] = None) -> VertBitSet:
    """
    Sample vertices, removing ones that are too close
    """
def positionVertsSmoothly(mesh: Mesh, verts: VertBitSet, edgeWeightsType: LaplacianEdgeWeightsParam = ..., fixedSharpVertices: VertBitSet = None) -> None:
    """
    Puts given vertices in such positions to make smooth surface both inside verts-region and on its boundary
    """
def projectAllMeshVertices(refMesh: Mesh, mesh: Mesh, refXf: AffineXf3f = None, xf: AffineXf3f = None, upDistLimitSq: float = 3.4028234663852886e+38, loDistLimitSq: float = 0.0) -> VectorFloatByVert:
    """
    computes signed distances from all mesh points to refMesh
    	refMesh all points will me projected to this mesh
    	mesh this mesh points will be projected
    	refXf world transform for refMesh
    	upDistLimitSq upper limit on the distance in question, if the real distance is larger than the returning upDistLimit
    	loDistLimitSq low limit on the distance in question, if a point is found within this distance then it is immediately returned without searching for a closer one
    """
@typing.overload
def rayMeshIntersect(meshPart: MeshPart, line: Line3f, rayStart: float = 0.0, rayEnd: float = 3.4028234663852886e+38, prec: IntersectionPrecomputesf = None, closestIntersect: bool = True) -> MeshIntersectionResult | None:
    """
    Finds ray and mesh intersection in float-precision.
    rayStart and rayEnd define the interval on the ray to detect an intersection.
    prec can be specified to reuse some precomputations (e.g. for checking many parallel rays).
    Finds the closest to ray origin intersection (or any intersection for better performance if !closestIntersect).
    """
@typing.overload
def rayMeshIntersect(meshPart: MeshPart, line: Line3d, rayStart: float = 0.0, rayEnd: float = 1.7976931348623157e+308, prec: IntersectionPrecomputesd = None, closestIntersect: bool = True) -> MeshIntersectionResult | None:
    """
    Finds ray and mesh intersection in double-precision.
    rayStart and rayEnd define the interval on the ray to detect an intersection.
    prec can be specified to reuse some precomputations (e.g. for checking many parallel rays).
    Finds the closest to ray origin intersection (or any intersection for better performance if !closestIntersect).
    """
def relax(mesh: Mesh, params: MeshRelaxParams = ..., cb: typing.Callable[[float], bool] = None) -> bool:
    """
    applies given number of relaxation iterations to the whole mesh ( or some region if it is specified )
    return true if was finished successfully, false if was interrupted by progress callback
    """
def relaxKeepVolume(mesh: Mesh, params: MeshRelaxParams = ..., cb: typing.Callable[[float], bool] = None) -> bool:
    """
    applies given number of relaxation iterations to the whole mesh ( or some region if it is specified ) 
    do not really keeps volume but tries hard 
    	return true if was finished successfully, false if was interrupted by progress callback
    """
def removeSpikes(mesh: Mesh, maxIterations: int, minSumAngle: float, region: VertBitSet = None) -> None:
    """
    applies at most given number of relaxation iterations the spikes detected by given threshold
    """
def saveAllSlicesToImage(vdbVolume: VdbVolume, settings: VoxelsSaveSavingSettings) -> None:
    """
    save all slices by the active plane through all voxel planes along the active axis to an image file
    """
def saveDistanceMapToImage(distMap: DistanceMap, filename: Path, threshold: float = 0.003921568859368563) -> None:
    """
    saves distance map to monochrome image in scales of gray:
    	threshold - threshold of maximum values [0.; 1.]. invalid pixel set as 0. (black)
    minimum (close): 1.0 (white)
    maximum (far): threshold
    invalid (infinity): 0.0 (black)
    """
@typing.overload
def saveLines(polyline: Polyline3, path: Path, callback: typing.Callable[[float], bool] = None) -> None:
    """
    detects the format from file extension and saves polyline in it
    """
@typing.overload
def saveLines(polyline: Polyline3, extension: str, fileHandle: typing.Any) -> None:
    """
    saves lines in python file handler, second arg: extension (`*.ext` format)
    """
@typing.overload
def saveMesh(mesh: Mesh, path: Path, colors: VertColorMap = None, callback: typing.Callable[[float], bool] = None) -> None:
    """
    detects the format from file extension and save mesh to it
    """
@typing.overload
def saveMesh(mesh: Mesh, extension: str, fileHandle: typing.Any) -> None:
    """
    saves mesh in python file handler, second arg: extension (`*.ext` format)
    """
@typing.overload
def savePoints(pointCloud: PointCloud, path: Path, colors: VertColorMap = None, callback: typing.Callable[[float], bool] = None) -> None:
    """
    detects the format from file extension and save points to it
    """
@typing.overload
def savePoints(pointCloud: PointCloud, extension: str, fileHandle: typing.Any) -> None:
    """
    saves point cloud in python file handler, second arg: extension (`*.ext` format)
    """
def saveSceneObject(object: SceneObject, path: Path, callback: typing.Callable[[float], bool] = None) -> None:
    """
    Detects the format from file extension and saves scene object to it. If the object doesn't contain any entities of the corresponding type, an empty file will be created.
    """
def saveSliceToImage(path: Path, vdbVolume: VdbVolume, slicePlane: SlicePlane, sliceNumber: int, cb: typing.Callable[[float], bool] = None) -> None:
    """
    Save the slice by the active plane through the sliceNumber to an image file.
    """
def saveVoxels(path: VdbVolume, VdbVoxels: Path, callback: typing.Callable[[float], bool] = None) -> None:
    """
    Save raw voxels file, writing parameters in name.
    """
def segmentByGraphCut(topology: MeshTopology, source: FaceBitSet, sink: FaceBitSet, metric: typing.Callable[[EdgeId], float]) -> FaceBitSet:
    """
    Finds segment that divide mesh on source and sink (source included, sink excluded), by minimizing the sum of metric over the boundary
    """
def setMeshToSelected(arg0: Mesh) -> None:
    """
    add mesh to scene tree and select it
    """
@typing.overload
def shrink(topology: MeshTopology, region: VertBitSet, hops: int = 1) -> None:
    """
    removes from the region all vertices within given number of hops (stars) from the initial region boundary
    """
@typing.overload
def shrink(topology: MeshTopology, region: FaceBitSet, hops: int = 1) -> None:
    """
    removes from the region all faces within given number of hops (stars) from the initial region boundary
    """
def simpleVolumeToDenseGrid(simpleVolume: SimpleVolume, cb: typing.Callable[[float], bool] = None) -> FloatGrid:
    """
    Make FloatGrid from SimpleVolume. Make copy of data.
    Grid can be used to make iso-surface later with gridToMesh function.
    """
def simpleVolumeToVdbVolume(simpleVolume: SimpleVolume, cb: typing.Callable[[float], bool] = None) -> VdbVolume:
    """
    Make VdbVolume from SimpleVolume. Make copy of data.
    Grid can be used to make iso-surface later with gridToMesh function.
    """
def subdivideMesh(mesh: Mesh, settings: SubdivideSettings = ...) -> int:
    """
    Split edges in mesh region according to the settings;
    return The total number of edge splits performed
    """
def suggestVoxelSize(mp: MeshPart, approxNumVoxels: float) -> float:
    """
    computes size of a cubical voxel to get approximately given number of voxels during rasterization
    """
def surfacePathLength(mesh: Mesh, surfacePath: SurfacePath) -> float:
    """
    Computes the length of surface path
    """
@typing.overload
def surroundingContour(mesh: Mesh, includeEdges: vectorEdges, edgeMetric: typing.Callable[[EdgeId], float], dir: Vector3f) -> vectorEdges:
    """
    Find the best closed edge loop passing through given edges, which minimizes the sum of given edge metric
    	includeEdges - contain all edges that must be present in the returned loop, probably with reversed direction (should have at least 2 elements)
    	edgeMetric - returned loop will minimize this metric
    	dir - direction approximately orthogonal to the loop
    """
@typing.overload
def surroundingContour(mesh: Mesh, keyVertices: vectorVerts, edgeMetric: typing.Callable[[EdgeId], float], dir: Vector3f) -> vectorEdges:
    """
    Find the best closed edge loop passing through given vertices, which minimizes the sum of given edge metric
    	keyVertices - contain all vertices that returned loop must pass (should have at least 2 elements)
    	edgeMetric - returned loop will minimize this metric
    	dir - direction approximately orthogonal to the loop
    """
def thickenMesh(mesh: Mesh, offset: float, params: OffsetParameters = ...) -> Mesh:
    """
    in case of positive offset, returns the mesh consisting of offset mesh merged with inversed original mesh (thickening mode);
    in case of negative offset, returns the mesh consisting of inversed offset mesh merged with original mesh (hollowing mode);
    if your input mesh is closed then please specify params.type == Offset, and you will get closed mesh on output;
    if your input mesh is open then please specify params.type == Shell, and you will get open mesh on output
    """
def topologyFromTriangles(triangulation: Triangulation, settings: MeshBuilderSettings = ...) -> MeshTopology:
    """
    construct mesh topology from a set of triangles with given ids;
    if skippedTris is given then it receives all input triangles not added in the resulting topology
    """
@typing.overload
def transformed(box: Box2f, xf: AffineXf2f) -> Box2f:
    """
    find the tightest box enclosing this one after transformation
    """
@typing.overload
def transformed(box: Box2f, xf: AffineXf2f) -> Box2f:
    """
    this version returns input box as is if pointer to transformation is null
    """
@typing.overload
def transformed(box: Box3f, xf: AffineXf3f) -> Box3f:
    """
    find the tightest box enclosing this one after transformation
    """
@typing.overload
def transformed(box: Box3f, xf: AffineXf3f) -> Box3f:
    """
    this version returns input box as is if pointer to transformation is null
    """
@typing.overload
def transformed(box: Box2d, xf: AffineXf2d) -> Box2d:
    """
    find the tightest box enclosing this one after transformation
    """
@typing.overload
def transformed(box: Box2d, xf: AffineXf2d) -> Box2d:
    """
    this version returns input box as is if pointer to transformation is null
    """
@typing.overload
def transformed(box: Box3d, xf: AffineXf3d) -> Box3d:
    """
    find the tightest box enclosing this one after transformation
    """
@typing.overload
def transformed(box: Box3d, xf: AffineXf3d) -> Box3d:
    """
    this version returns input box as is if pointer to transformation is null
    """
def triangulateContours(contours: Contours2f, holeVertsIds: HolesVertIds = None) -> Mesh:
    """
    Triangulate 2d contours.
    Only closed contours are allowed (first point of each contour should be the same as last point of the contour).
    	holeVertsIds if set merge only points with same vertex id, otherwise merge all points with same coordinates
    	return created mesh
    """
def triangulatePointCloud(pointCloud: PointCloud, params: TriangulationParameters = ..., progressCb: typing.Callable[[float], bool] = None) -> Mesh | None:
    """
    Creates mesh from given point cloud according params
    Returns empty optional if was interrupted by progress bar
    """
def uniteManyMeshes(meshes: vectorConstMeshPtr, params: UniteManyMeshesParams = ...) -> Mesh:
    """
    Computes the surface of objects' union each of which is defined by its own surface mesh
    - merge non intersecting meshes first
    - unite merged groups
    """
def voxelBooleanIntersect(meshA: Mesh, meshB: Mesh, voxelSize: float) -> Mesh:
    """
    intersect mesh A and mesh B
    """
def voxelBooleanSubtract(meshA: Mesh, meshB: Mesh, voxelSize: float) -> Mesh:
    """
    subtract mesh B from mesh A
    """
def voxelBooleanUnite(meshA: Mesh, meshB: Mesh, voxelSize: float) -> Mesh:
    """
    unite mesh A and mesh B
    """
